/* gnome-shell-extension.c generated by valac 0.56.14, the Vala compiler
 * generated from gnome-shell-extension.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include "gnome.h"

#define GNOME_PLUGIN_SCRIPT_WRAPPER "\n(function() {\n    ${SCRIPT}\n\n    return null;\n})();\n"
#define GNOME_PLUGIN_LOAD_SCRIPT "\n" \
"const { Gio } = imports.gi;\n" \
"const FileUtils = imports.misc.fileUtils;\n" \
"const { ExtensionType } = imports.misc.extensionUtils;\n" \
"\n" \
"let perUserDir = Gio.File.new_for_path(global.userdatadir);\n" \
"let uuid = '${UUID}';\n" \
"let extension = Main.extensionManager.lookup(uuid);\n" \
"\n" \
"if (extension)\n" \
"    return;\n" \
"\n" \
"FileUtils.collectFromDatadirs('extensions', true, (dir, info) => {\n" \
"    let fileType = info.get_file_type();\n" \
"    if (fileType != Gio.FileType.DIRECTORY)\n" \
"        return;\n" \
"\n" \
"    if (info.get_name() != uuid)\n" \
"        return;\n" \
"\n" \
"    let extensionType = dir.has_prefix(perUserDir)\n" \
"        ? ExtensionType.PER_USER\n" \
"        : ExtensionType.SYSTEM;\n" \
"    try {\n" \
"        Main.extensionManager.loadExtension(\n" \
"            Main.extensionManager.createExtensionObject(uuid, dir, ext" \
"ensionType)\n" \
"        );\n" \
"    } catch (error) {\n" \
"        logError(error, 'Could not load extension %s'.format(uuid));\n" \
"        throw error;\n" \
"    }\n" \
"});\n" \
"extension = Main.extensionManager.lookup(uuid);\n" \
"if (!extension)\n" \
"    throw new Error('Could not find extension %s'.format(uuid));\n"
#define GNOME_PLUGIN_RELOAD_SCRIPT "\n" \
"let uuid = '${UUID}';\n" \
"let extension = Main.extensionManager.lookup(uuid);\n" \
"\n" \
"try {\n" \
"    if (extension)\n" \
"        Main.extensionManager.reloadExtension(extension);\n" \
"    else\n" \
"        throw new Error('Could not find extension %s'.format(uuid));\n" \
"} catch (error) {\n" \
"    logError(error, 'Error while reloading extension %s'.format(uuid))" \
";\n" \
"    throw error;\n" \
"}\n"

#define GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION_ERROR (gnome_plugin_gnome_shell_extension_error_get_type ())

#define GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION (gnome_plugin_gnome_shell_extension_get_type ())
#define GNOME_PLUGIN_GNOME_SHELL_EXTENSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION, GnomePluginGnomeShellExtension))
#define GNOME_PLUGIN_GNOME_SHELL_EXTENSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION, GnomePluginGnomeShellExtensionClass))
#define GNOME_PLUGIN_IS_GNOME_SHELL_EXTENSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION))
#define GNOME_PLUGIN_IS_GNOME_SHELL_EXTENSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION))
#define GNOME_PLUGIN_GNOME_SHELL_EXTENSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION, GnomePluginGnomeShellExtensionClass))

typedef struct _GnomePluginGnomeShellExtension GnomePluginGnomeShellExtension;
typedef struct _GnomePluginGnomeShellExtensionClass GnomePluginGnomeShellExtensionClass;
typedef struct _GnomePluginGnomeShellExtensionPrivate GnomePluginGnomeShellExtensionPrivate;
enum  {
	GNOME_PLUGIN_GNOME_SHELL_EXTENSION_0_PROPERTY,
	GNOME_PLUGIN_GNOME_SHELL_EXTENSION_UUID_PROPERTY,
	GNOME_PLUGIN_GNOME_SHELL_EXTENSION_PATH_PROPERTY,
	GNOME_PLUGIN_GNOME_SHELL_EXTENSION_VERSION_PROPERTY,
	GNOME_PLUGIN_GNOME_SHELL_EXTENSION_STATE_PROPERTY,
	GNOME_PLUGIN_GNOME_SHELL_EXTENSION_NUM_PROPERTIES
};
static GParamSpec* gnome_plugin_gnome_shell_extension_properties[GNOME_PLUGIN_GNOME_SHELL_EXTENSION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _GnomePluginGnomeShellExtensionInitAsyncData GnomePluginGnomeShellExtensionInitAsyncData;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GnomePluginGnomeShellExtensionUpdateData GnomePluginGnomeShellExtensionUpdateData;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _GnomePluginGnomeShellExtensionLoadData GnomePluginGnomeShellExtensionLoadData;
typedef struct _GnomePluginGnomeShellExtensionReloadData GnomePluginGnomeShellExtensionReloadData;
typedef struct _GnomePluginGnomeShellExtensionEnableData GnomePluginGnomeShellExtensionEnableData;
typedef struct _GnomePluginGnomeShellExtensionDisableData GnomePluginGnomeShellExtensionDisableData;
enum  {
	GNOME_PLUGIN_GNOME_SHELL_EXTENSION_STATE_CHANGED_SIGNAL,
	GNOME_PLUGIN_GNOME_SHELL_EXTENSION_NUM_SIGNALS
};
static guint gnome_plugin_gnome_shell_extension_signals[GNOME_PLUGIN_GNOME_SHELL_EXTENSION_NUM_SIGNALS] = {0};

typedef enum  {
	GNOME_PLUGIN_GNOME_SHELL_EXTENSION_ERROR_SYNC_ERROR,
	GNOME_PLUGIN_GNOME_SHELL_EXTENSION_ERROR_EVAL_ERROR
} GnomePluginGnomeShellExtensionError;
#define GNOME_PLUGIN_GNOME_SHELL_EXTENSION_ERROR gnome_plugin_gnome_shell_extension_error_quark ()

struct _GnomePluginGnomeShellExtension {
	GObject parent_instance;
	GnomePluginGnomeShellExtensionPrivate * priv;
};

struct _GnomePluginGnomeShellExtensionClass {
	GObjectClass parent_class;
	void (*init_async) (GnomePluginGnomeShellExtension* self, gint io_priority, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*init_finish) (GnomePluginGnomeShellExtension* self, GAsyncResult* _res_, GError** error);
};

struct _GnomePluginGnomeShellExtensionPrivate {
	gchar* _uuid;
	gchar* _path;
	gchar* _version;
	GnomeExtensionState _state;
	GnomeShell* shell_proxy;
	GnomeShellExtensions* shell_extensions_proxy;
	gulong extension_state_changed_id;
};

struct _GnomePluginGnomeShellExtensionInitAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GnomePluginGnomeShellExtension* self;
	gint io_priority;
	GCancellable* cancellable;
	gboolean result;
	GError* _tmp0_;
	GnomeShellExtensions* _tmp1_;
	gulong _tmp2_;
	GError* _inner_error0_;
};

struct _GnomePluginGnomeShellExtensionUpdateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GnomePluginGnomeShellExtension* self;
	GCancellable* cancellable;
	GHashTable* data;
	const gchar* _tmp0_;
	GHashTable* _tmp1_;
	GnomeShellExtensions* _tmp2_;
	const gchar* _tmp3_;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	GError* _error_;
	GError* _tmp6_;
	const gchar* _tmp7_;
	GError* _tmp8_;
	GError* _tmp9_;
	GHashTable* _tmp10_;
	GError* _vala1__error_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GError* _tmp13_;
	GError* _tmp14_;
	GError* _inner_error0_;
};

struct _GnomePluginGnomeShellExtensionLoadData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GnomePluginGnomeShellExtension* self;
	GCancellable* cancellable;
	gboolean result;
	gboolean _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GError* _error_;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GnomeExtensionState _tmp6_;
	GError* _inner_error0_;
};

struct _GnomePluginGnomeShellExtensionReloadData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GnomePluginGnomeShellExtension* self;
	GCancellable* cancellable;
	gboolean result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GnomeExtensionState _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
	gchar* previous_path;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* previous_version;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GError* _error_;
	GError* _tmp12_;
	const gchar* _tmp13_;
	GnomeExtensionState _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GError* _tmp19_;
	const gchar* _tmp20_;
	GError* _tmp21_;
	gboolean _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	GError* _inner_error0_;
};

struct _GnomePluginGnomeShellExtensionEnableData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GnomePluginGnomeShellExtension* self;
	GCancellable* cancellable;
	gboolean result;
	const gchar* _tmp0_;
	GError* _error_;
	GError* _tmp1_;
	const gchar* _tmp2_;
	GnomeShellExtensions* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GnomeShellExtensions* _tmp6_;
	const gchar* _tmp7_;
	GError* _vala1__error_;
	GError* _tmp8_;
	const gchar* _tmp9_;
	GnomeExtensionState _tmp10_;
	GError* _inner_error0_;
};

struct _GnomePluginGnomeShellExtensionDisableData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GnomePluginGnomeShellExtension* self;
	GCancellable* cancellable;
	gboolean result;
	GnomeShellExtensions* _tmp0_;
	const gchar* _tmp1_;
	GError* _error_;
	GError* _tmp2_;
	const gchar* _tmp3_;
	GnomeExtensionState _tmp4_;
	GError* _inner_error0_;
};

static gint GnomePluginGnomeShellExtension_private_offset;
static gpointer gnome_plugin_gnome_shell_extension_parent_class = NULL;
static GAsyncInitableIface * gnome_plugin_gnome_shell_extension_g_async_initable_parent_iface = NULL;
static GType gnome_plugin_gnome_shell_extension_type_id = 0;

VALA_EXTERN GQuark gnome_plugin_gnome_shell_extension_error_quark (void);
VALA_EXTERN GType gnome_plugin_gnome_shell_extension_error_get_type (void) G_GNUC_CONST ;
GType gnome_plugin_gnome_shell_extension_register_type (GTypeModule * module);
VALA_EXTERN GType gnome_plugin_gnome_shell_extension_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void gnome_plugin_gnome_shell_extension_init_async (GnomePluginGnomeShellExtension* self,
                                                    gint io_priority,
                                                    GCancellable* cancellable,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
VALA_EXTERN gboolean gnome_plugin_gnome_shell_extension_init_finish (GnomePluginGnomeShellExtension* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
VALA_EXTERN GnomePluginGnomeShellExtension* gnome_plugin_gnome_shell_extension_new (GnomeShell* shell_proxy,
                                                                        GnomeShellExtensions* shell_extensions_proxy,
                                                                        const gchar* uuid);
VALA_EXTERN GnomePluginGnomeShellExtension* gnome_plugin_gnome_shell_extension_construct (GType object_type,
                                                                              GnomeShell* shell_proxy,
                                                                              GnomeShellExtensions* shell_extensions_proxy,
                                                                              const gchar* uuid);
static void gnome_plugin_gnome_shell_extension_real_init_async_data_free (gpointer _data);
static void gnome_plugin_gnome_shell_extension_real_init_async (GnomePluginGnomeShellExtension* self,
                                                         gint io_priority,
                                                         GCancellable* cancellable,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_);
static gboolean gnome_plugin_gnome_shell_extension_real_init_async_co (GnomePluginGnomeShellExtensionInitAsyncData* _data_);
static void gnome_plugin_gnome_shell_extension_update (GnomePluginGnomeShellExtension* self,
                                                GCancellable* cancellable,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void gnome_plugin_gnome_shell_extension_update_finish (GnomePluginGnomeShellExtension* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
static void gnome_plugin_gnome_shell_extension_init_async_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void gnome_plugin_gnome_shell_extension_on_extension_state_changed (GnomePluginGnomeShellExtension* self,
                                                                    const gchar* uuid,
                                                                    GHashTable* data);
static void _gnome_plugin_gnome_shell_extension_on_extension_state_changed_gnome_shell_extensions_extension_state_changed (GnomeShellExtensions* _sender,
                                                                                                                    const gchar* uuid,
                                                                                                                    GHashTable* state,
                                                                                                                    gpointer self);
static void gnome_plugin_gnome_shell_extension_do_update (GnomePluginGnomeShellExtension* self,
                                                   GHashTable* data,
                                                   GError** error);
VALA_EXTERN const gchar* gnome_plugin_gnome_shell_extension_get_uuid (GnomePluginGnomeShellExtension* self);
VALA_EXTERN GnomeExtensionState gnome_plugin_gnome_shell_extension_get_state (GnomePluginGnomeShellExtension* self);
VALA_EXTERN const gchar* gnome_plugin_gnome_shell_extension_get_path (GnomePluginGnomeShellExtension* self);
VALA_EXTERN const gchar* gnome_plugin_gnome_shell_extension_get_version (GnomePluginGnomeShellExtension* self);
VALA_EXTERN void gnome_plugin_gnome_shell_extension_set_path (GnomePluginGnomeShellExtension* self,
                                                  const gchar* value);
VALA_EXTERN void gnome_plugin_gnome_shell_extension_set_version (GnomePluginGnomeShellExtension* self,
                                                     const gchar* value);
VALA_EXTERN void gnome_plugin_gnome_shell_extension_set_state (GnomePluginGnomeShellExtension* self,
                                                   GnomeExtensionState value);
static void gnome_plugin_gnome_shell_extension_update_data_free (gpointer _data);
static gboolean gnome_plugin_gnome_shell_extension_update_co (GnomePluginGnomeShellExtensionUpdateData* _data_);
static void gnome_plugin_gnome_shell_extension_update_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void gnome_plugin_gnome_shell_extension_eval_script (GnomePluginGnomeShellExtension* self,
                                                     const gchar* script,
                                                     GError** error);
static void gnome_plugin_gnome_shell_extension_load_data_free (gpointer _data);
VALA_EXTERN void gnome_plugin_gnome_shell_extension_load (GnomePluginGnomeShellExtension* self,
                                              GCancellable* cancellable,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
VALA_EXTERN gboolean gnome_plugin_gnome_shell_extension_load_finish (GnomePluginGnomeShellExtension* self,
                                                         GAsyncResult* _res_,
                                                         GError** error);
static gboolean gnome_plugin_gnome_shell_extension_load_co (GnomePluginGnomeShellExtensionLoadData* _data_);
static void gnome_plugin_gnome_shell_extension_load_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void gnome_plugin_gnome_shell_extension_reload_data_free (gpointer _data);
VALA_EXTERN void gnome_plugin_gnome_shell_extension_reload (GnomePluginGnomeShellExtension* self,
                                                GCancellable* cancellable,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
VALA_EXTERN gboolean gnome_plugin_gnome_shell_extension_reload_finish (GnomePluginGnomeShellExtension* self,
                                                           GAsyncResult* _res_,
                                                           GError** error);
static gboolean gnome_plugin_gnome_shell_extension_reload_co (GnomePluginGnomeShellExtensionReloadData* _data_);
static void gnome_plugin_gnome_shell_extension_reload_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void gnome_plugin_gnome_shell_extension_enable_data_free (gpointer _data);
VALA_EXTERN void gnome_plugin_gnome_shell_extension_enable (GnomePluginGnomeShellExtension* self,
                                                GCancellable* cancellable,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
VALA_EXTERN gboolean gnome_plugin_gnome_shell_extension_enable_finish (GnomePluginGnomeShellExtension* self,
                                                           GAsyncResult* _res_);
static gboolean gnome_plugin_gnome_shell_extension_enable_co (GnomePluginGnomeShellExtensionEnableData* _data_);
static void gnome_plugin_gnome_shell_extension_enable_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void gnome_plugin_gnome_shell_extension_disable_data_free (gpointer _data);
VALA_EXTERN void gnome_plugin_gnome_shell_extension_disable (GnomePluginGnomeShellExtension* self,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
VALA_EXTERN gboolean gnome_plugin_gnome_shell_extension_disable_finish (GnomePluginGnomeShellExtension* self,
                                                            GAsyncResult* _res_);
static gboolean gnome_plugin_gnome_shell_extension_disable_co (GnomePluginGnomeShellExtensionDisableData* _data_);
static void gnome_plugin_gnome_shell_extension_disable_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
static void gnome_plugin_gnome_shell_extension_real_dispose (GObject* base);
VALA_EXTERN void gnome_plugin_gnome_shell_extension_set_uuid (GnomePluginGnomeShellExtension* self,
                                                  const gchar* value);
static void gnome_plugin_gnome_shell_extension_finalize (GObject * obj);
static void _vala_gnome_plugin_gnome_shell_extension_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec);
static void _vala_gnome_plugin_gnome_shell_extension_set_property (GObject * object,
                                                            guint property_id,
                                                            const GValue * value,
                                                            GParamSpec * pspec);

GQuark
gnome_plugin_gnome_shell_extension_error_quark (void)
{
	return g_quark_from_static_string ("gnome-plugin-gnome-shell-extension-error-quark");
}

static GType
gnome_plugin_gnome_shell_extension_error_get_type_once (void)
{
	static const GEnumValue values[] = {{GNOME_PLUGIN_GNOME_SHELL_EXTENSION_ERROR_SYNC_ERROR, "GNOME_PLUGIN_GNOME_SHELL_EXTENSION_ERROR_SYNC_ERROR", "sync-error"}, {GNOME_PLUGIN_GNOME_SHELL_EXTENSION_ERROR_EVAL_ERROR, "GNOME_PLUGIN_GNOME_SHELL_EXTENSION_ERROR_EVAL_ERROR", "eval-error"}, {0, NULL, NULL}};
	GType gnome_plugin_gnome_shell_extension_error_type_id;
	gnome_plugin_gnome_shell_extension_error_type_id = g_enum_register_static ("GnomePluginGnomeShellExtensionError", values);
	return gnome_plugin_gnome_shell_extension_error_type_id;
}

GType
gnome_plugin_gnome_shell_extension_error_get_type (void)
{
	static volatile gsize gnome_plugin_gnome_shell_extension_error_type_id__once = 0;
	if (g_once_init_enter (&gnome_plugin_gnome_shell_extension_error_type_id__once)) {
		GType gnome_plugin_gnome_shell_extension_error_type_id;
		gnome_plugin_gnome_shell_extension_error_type_id = gnome_plugin_gnome_shell_extension_error_get_type_once ();
		g_once_init_leave (&gnome_plugin_gnome_shell_extension_error_type_id__once, gnome_plugin_gnome_shell_extension_error_type_id);
	}
	return gnome_plugin_gnome_shell_extension_error_type_id__once;
}

static inline gpointer
gnome_plugin_gnome_shell_extension_get_instance_private (GnomePluginGnomeShellExtension* self)
{
	return G_STRUCT_MEMBER_P (self, GnomePluginGnomeShellExtension_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 112 "../plugins/gnome/gnome-shell-extension.vala"
	return self ? g_object_ref (self) : NULL;
#line 415 "gnome-shell-extension.c"
}

GnomePluginGnomeShellExtension*
gnome_plugin_gnome_shell_extension_construct (GType object_type,
                                              GnomeShell* shell_proxy,
                                              GnomeShellExtensions* shell_extensions_proxy,
                                              const gchar* uuid)
{
	GnomePluginGnomeShellExtension * self = NULL;
	GnomeShell* _tmp0_;
	GnomeShellExtensions* _tmp1_;
#line 104 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_val_if_fail (shell_proxy != NULL, NULL);
#line 104 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_val_if_fail (shell_extensions_proxy != NULL, NULL);
#line 104 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 108 "../plugins/gnome/gnome-shell-extension.vala"
	self = (GnomePluginGnomeShellExtension*) g_object_new (object_type, "uuid", uuid, "path", "", "version", "", NULL);
#line 112 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp0_ = _g_object_ref0 (shell_proxy);
#line 112 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (self->priv->shell_proxy);
#line 112 "../plugins/gnome/gnome-shell-extension.vala"
	self->priv->shell_proxy = _tmp0_;
#line 113 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp1_ = _g_object_ref0 (shell_extensions_proxy);
#line 113 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (self->priv->shell_extensions_proxy);
#line 113 "../plugins/gnome/gnome-shell-extension.vala"
	self->priv->shell_extensions_proxy = _tmp1_;
#line 104 "../plugins/gnome/gnome-shell-extension.vala"
	return self;
#line 449 "gnome-shell-extension.c"
}

GnomePluginGnomeShellExtension*
gnome_plugin_gnome_shell_extension_new (GnomeShell* shell_proxy,
                                        GnomeShellExtensions* shell_extensions_proxy,
                                        const gchar* uuid)
{
#line 104 "../plugins/gnome/gnome-shell-extension.vala"
	return gnome_plugin_gnome_shell_extension_construct (GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION, shell_proxy, shell_extensions_proxy, uuid);
#line 459 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_real_init_async_data_free (gpointer _data)
{
	GnomePluginGnomeShellExtensionInitAsyncData* _data_;
	_data_ = _data;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->self);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_slice_free (GnomePluginGnomeShellExtensionInitAsyncData, _data_);
#line 473 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_real_init_async (GnomePluginGnomeShellExtension* self,
                                                    gint io_priority,
                                                    GCancellable* cancellable,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_)
{
	GnomePluginGnomeShellExtensionInitAsyncData* _data_;
	GnomePluginGnomeShellExtension* _tmp0_;
	GCancellable* _tmp1_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = g_slice_new0 (GnomePluginGnomeShellExtensionInitAsyncData);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gnome_plugin_gnome_shell_extension_real_init_async_data_free);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->self = _tmp0_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->io_priority = io_priority;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->cancellable = _tmp1_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_real_init_async_co (_data_);
#line 506 "gnome-shell-extension.c"
}

static gboolean
gnome_plugin_gnome_shell_extension_real_init_finish (GnomePluginGnomeShellExtension* self,
                                                     GAsyncResult* _res_,
                                                     GError** error)
{
	gboolean result;
	GnomePluginGnomeShellExtensionInitAsyncData* _data_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	if (NULL == _data_) {
#line 520 "gnome-shell-extension.c"
		gboolean _tmp0_ = FALSE;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		return _tmp0_;
#line 524 "gnome-shell-extension.c"
	}
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	result = _data_->result;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	return result;
#line 530 "gnome-shell-extension.c"
}

/**
         * Initialize D-Bus proxy and fetch extension state
         */
static void
gnome_plugin_gnome_shell_extension_init_async_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	GnomePluginGnomeShellExtensionInitAsyncData* _data_;
#line 124 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = _user_data_;
#line 124 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_source_object_ = source_object;
#line 124 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_res_ = _res_;
#line 124 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_real_init_async_co (_data_);
#line 550 "gnome-shell-extension.c"
}

static void
_gnome_plugin_gnome_shell_extension_on_extension_state_changed_gnome_shell_extensions_extension_state_changed (GnomeShellExtensions* _sender,
                                                                                                               const gchar* uuid,
                                                                                                               GHashTable* state,
                                                                                                               gpointer self)
{
#line 130 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_on_extension_state_changed ((GnomePluginGnomeShellExtension*) self, uuid, state);
#line 561 "gnome-shell-extension.c"
}

static gboolean
gnome_plugin_gnome_shell_extension_real_init_async_co (GnomePluginGnomeShellExtensionInitAsyncData* _data_)
{
#line 119 "../plugins/gnome/gnome-shell-extension.vala"
	switch (_data_->_state_) {
#line 119 "../plugins/gnome/gnome-shell-extension.vala"
		case 0:
#line 571 "gnome-shell-extension.c"
		goto _state_0;
#line 119 "../plugins/gnome/gnome-shell-extension.vala"
		case 1:
#line 575 "gnome-shell-extension.c"
		goto _state_1;
		default:
#line 119 "../plugins/gnome/gnome-shell-extension.vala"
		g_assert_not_reached ();
#line 580 "gnome-shell-extension.c"
	}
	_state_0:
	{
#line 124 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_state_ = 1;
#line 124 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_update (_data_->self, _data_->cancellable, gnome_plugin_gnome_shell_extension_init_async_ready, _data_);
#line 124 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 590 "gnome-shell-extension.c"
		_state_1:
#line 124 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_update_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 124 "../plugins/gnome/gnome-shell-extension.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 596 "gnome-shell-extension.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 123 "../plugins/gnome/gnome-shell-extension.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 127 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp0_ = g_error_new_literal (GNOME_PLUGIN_GNOME_SHELL_EXTENSION_ERROR, GNOME_PLUGIN_GNOME_SHELL_EXTENSION_ERROR_SYNC_ERROR, "Unable to fetch extension state");
#line 127 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_inner_error0_ = _data_->_tmp0_;
#line 609 "gnome-shell-extension.c"
		goto __finally0;
	}
	__finally0:
#line 123 "../plugins/gnome/gnome-shell-extension.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 123 "../plugins/gnome/gnome-shell-extension.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 123 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_unref (_data_->_async_result);
#line 123 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 621 "gnome-shell-extension.c"
	}
#line 130 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp1_ = _data_->self->priv->shell_extensions_proxy;
#line 130 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp2_ = g_signal_connect_object (_data_->_tmp1_, "extension-state-changed", (GCallback) _gnome_plugin_gnome_shell_extension_on_extension_state_changed_gnome_shell_extensions_extension_state_changed, _data_->self, 0);
#line 130 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->self->priv->extension_state_changed_id = _data_->_tmp2_;
#line 133 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->result = TRUE;
#line 133 "../plugins/gnome/gnome-shell-extension.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 133 "../plugins/gnome/gnome-shell-extension.vala"
	if (_data_->_state_ != 0) {
#line 133 "../plugins/gnome/gnome-shell-extension.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 133 "../plugins/gnome/gnome-shell-extension.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 639 "gnome-shell-extension.c"
		}
	}
#line 133 "../plugins/gnome/gnome-shell-extension.vala"
	g_object_unref (_data_->_async_result);
#line 133 "../plugins/gnome/gnome-shell-extension.vala"
	return FALSE;
#line 646 "gnome-shell-extension.c"
}

void
gnome_plugin_gnome_shell_extension_init_async (GnomePluginGnomeShellExtension* self,
                                               gint io_priority,
                                               GCancellable* cancellable,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	GnomePluginGnomeShellExtensionClass* _klass_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_klass_ = GNOME_PLUGIN_GNOME_SHELL_EXTENSION_GET_CLASS (self);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	if (_klass_->init_async) {
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		_klass_->init_async (self, io_priority, cancellable, _callback_, _user_data_);
#line 663 "gnome-shell-extension.c"
	}
}

gboolean
gnome_plugin_gnome_shell_extension_init_finish (GnomePluginGnomeShellExtension* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	GnomePluginGnomeShellExtensionClass* _klass_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_klass_ = GNOME_PLUGIN_GNOME_SHELL_EXTENSION_GET_CLASS (self);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	if (_klass_->init_finish) {
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		return _klass_->init_finish (self, _res_, error);
#line 679 "gnome-shell-extension.c"
	}
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	return FALSE;
#line 683 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_do_update (GnomePluginGnomeShellExtension* self,
                                              GHashTable* data,
                                              GError** error)
{
	GnomeExtensionInfo extension_info = {0};
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GnomeExtensionInfo _tmp3_;
	GnomeExtensionState _tmp4_;
	GError* _inner_error0_ = NULL;
#line 136 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (self != NULL);
#line 136 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (data != NULL);
#line 138 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp0_ = self->priv->_uuid;
#line 138 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_extension_info_init_deserialize (&extension_info, _tmp0_, data, &_inner_error0_);
#line 138 "../plugins/gnome/gnome-shell-extension.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 138 "../plugins/gnome/gnome-shell-extension.vala"
		g_propagate_error (error, _inner_error0_);
#line 138 "../plugins/gnome/gnome-shell-extension.vala"
		return;
#line 712 "gnome-shell-extension.c"
	}
#line 141 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp3_ = extension_info;
#line 141 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp4_ = self->priv->_state;
#line 141 "../plugins/gnome/gnome-shell-extension.vala"
	if (_tmp3_.state != _tmp4_) {
#line 141 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp2_ = TRUE;
#line 722 "gnome-shell-extension.c"
	} else {
		GnomeExtensionInfo _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 142 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp5_ = extension_info;
#line 142 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp6_ = _tmp5_.path;
#line 142 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp7_ = self->priv->_path;
#line 142 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp2_ = g_strcmp0 (_tmp6_, _tmp7_) != 0;
#line 735 "gnome-shell-extension.c"
	}
#line 141 "../plugins/gnome/gnome-shell-extension.vala"
	if (_tmp2_) {
#line 141 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp1_ = TRUE;
#line 741 "gnome-shell-extension.c"
	} else {
		GnomeExtensionInfo _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 143 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp8_ = extension_info;
#line 143 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp9_ = _tmp8_.version;
#line 143 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp10_ = self->priv->_version;
#line 143 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp1_ = g_strcmp0 (_tmp9_, _tmp10_) != 0;
#line 754 "gnome-shell-extension.c"
	}
#line 140 "../plugins/gnome/gnome-shell-extension.vala"
	if (_tmp1_) {
#line 758 "gnome-shell-extension.c"
		GnomeExtensionInfo _tmp11_;
#line 145 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_freeze_notify ((GObject*) self);
#line 147 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp11_ = extension_info;
#line 147 "../plugins/gnome/gnome-shell-extension.vala"
		if (_tmp11_.state != GNOME_EXTENSION_STATE_UNINSTALLED) {
#line 766 "gnome-shell-extension.c"
			GnomeExtensionInfo _tmp12_;
			const gchar* _tmp13_;
			GnomeExtensionInfo _tmp14_;
			const gchar* _tmp15_;
			GnomeExtensionInfo _tmp16_;
#line 149 "../plugins/gnome/gnome-shell-extension.vala"
			_tmp12_ = extension_info;
#line 149 "../plugins/gnome/gnome-shell-extension.vala"
			_tmp13_ = _tmp12_.path;
#line 149 "../plugins/gnome/gnome-shell-extension.vala"
			gnome_plugin_gnome_shell_extension_set_path (self, _tmp13_);
#line 150 "../plugins/gnome/gnome-shell-extension.vala"
			_tmp14_ = extension_info;
#line 150 "../plugins/gnome/gnome-shell-extension.vala"
			_tmp15_ = _tmp14_.version;
#line 150 "../plugins/gnome/gnome-shell-extension.vala"
			gnome_plugin_gnome_shell_extension_set_version (self, _tmp15_);
#line 151 "../plugins/gnome/gnome-shell-extension.vala"
			_tmp16_ = extension_info;
#line 151 "../plugins/gnome/gnome-shell-extension.vala"
			gnome_plugin_gnome_shell_extension_set_state (self, _tmp16_.state);
#line 788 "gnome-shell-extension.c"
		} else {
			GnomeExtensionInfo _tmp17_;
#line 154 "../plugins/gnome/gnome-shell-extension.vala"
			_tmp17_ = extension_info;
#line 154 "../plugins/gnome/gnome-shell-extension.vala"
			gnome_plugin_gnome_shell_extension_set_state (self, _tmp17_.state);
#line 795 "gnome-shell-extension.c"
		}
#line 157 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_thaw_notify ((GObject*) self);
#line 159 "../plugins/gnome/gnome-shell-extension.vala"
		g_signal_emit (self, gnome_plugin_gnome_shell_extension_signals[GNOME_PLUGIN_GNOME_SHELL_EXTENSION_STATE_CHANGED_SIGNAL], 0);
#line 801 "gnome-shell-extension.c"
	}
#line 136 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_extension_info_destroy (&extension_info);
#line 805 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_update_data_free (gpointer _data)
{
	GnomePluginGnomeShellExtensionUpdateData* _data_;
	_data_ = _data;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->self);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_slice_free (GnomePluginGnomeShellExtensionUpdateData, _data_);
#line 819 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_update (GnomePluginGnomeShellExtension* self,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	GnomePluginGnomeShellExtensionUpdateData* _data_;
	GnomePluginGnomeShellExtension* _tmp0_;
	GCancellable* _tmp1_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (self != NULL);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = g_slice_new0 (GnomePluginGnomeShellExtensionUpdateData);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gnome_plugin_gnome_shell_extension_update_data_free);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->self = _tmp0_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->cancellable = _tmp1_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_update_co (_data_);
#line 851 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_update_finish (GnomePluginGnomeShellExtension* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	GnomePluginGnomeShellExtensionUpdateData* _data_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	if (NULL == _data_) {
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		return;
#line 866 "gnome-shell-extension.c"
	}
}

/**
         * Fetch extension info/state
         */
static void
gnome_plugin_gnome_shell_extension_update_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	GnomePluginGnomeShellExtensionUpdateData* _data_;
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = _user_data_;
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_source_object_ = source_object;
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_res_ = _res_;
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_update_co (_data_);
#line 887 "gnome-shell-extension.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 176 "../plugins/gnome/gnome-shell-extension.vala"
	return self ? g_error_copy (self) : NULL;
#line 895 "gnome-shell-extension.c"
}

static gboolean
gnome_plugin_gnome_shell_extension_update_co (GnomePluginGnomeShellExtensionUpdateData* _data_)
{
#line 166 "../plugins/gnome/gnome-shell-extension.vala"
	switch (_data_->_state_) {
#line 166 "../plugins/gnome/gnome-shell-extension.vala"
		case 0:
#line 905 "gnome-shell-extension.c"
		goto _state_0;
#line 166 "../plugins/gnome/gnome-shell-extension.vala"
		case 1:
#line 909 "gnome-shell-extension.c"
		goto _state_1;
		default:
#line 166 "../plugins/gnome/gnome-shell-extension.vala"
		g_assert_not_reached ();
#line 914 "gnome-shell-extension.c"
	}
	_state_0:
	{
#line 171 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp0_ = _data_->self->priv->_uuid;
#line 171 "../plugins/gnome/gnome-shell-extension.vala"
		g_debug ("gnome-shell-extension.vala:171: Fetching extension info of \"%s\"…", _data_->_tmp0_);
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp2_ = _data_->self->priv->shell_extensions_proxy;
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp3_ = _data_->self->priv->_uuid;
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_state_ = 1;
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_shell_extensions_get_extension_info (_data_->_tmp2_, _data_->_tmp3_, _data_->cancellable, gnome_plugin_gnome_shell_extension_update_ready, _data_);
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 932 "gnome-shell-extension.c"
		_state_1:
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp4_ = gnome_shell_extensions_get_extension_info_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp1_ = _data_->_tmp4_;
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 940 "gnome-shell-extension.c"
			goto __catch0_g_error;
		}
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp5_ = _data_->_tmp1_;
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp1_ = NULL;
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
		_g_hash_table_unref0 (_data_->data);
#line 172 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->data = _data_->_tmp5_;
#line 170 "../plugins/gnome/gnome-shell-extension.vala"
		_g_hash_table_unref0 (_data_->_tmp1_);
#line 953 "gnome-shell-extension.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 170 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 170 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_inner_error0_ = NULL;
#line 175 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp6_ = _data_->_error_;
#line 175 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp7_ = _data_->_tmp6_->message;
#line 175 "../plugins/gnome/gnome-shell-extension.vala"
		g_warning ("gnome-shell-extension.vala:175: Error while fetching extension state: " \
"%s", _data_->_tmp7_);
#line 176 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp8_ = _data_->_error_;
#line 176 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp9_ = _g_error_copy0 (_data_->_tmp8_);
#line 176 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_inner_error0_ = _data_->_tmp9_;
#line 176 "../plugins/gnome/gnome-shell-extension.vala"
		_g_error_free0 (_data_->_error_);
#line 976 "gnome-shell-extension.c"
		goto __finally0;
	}
	__finally0:
#line 170 "../plugins/gnome/gnome-shell-extension.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 170 "../plugins/gnome/gnome-shell-extension.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 170 "../plugins/gnome/gnome-shell-extension.vala"
		_g_hash_table_unref0 (_data_->data);
#line 170 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_unref (_data_->_async_result);
#line 170 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 990 "gnome-shell-extension.c"
	}
	{
#line 180 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp10_ = _data_->data;
#line 180 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_do_update (_data_->self, _data_->_tmp10_, &_data_->_inner_error0_);
#line 180 "../plugins/gnome/gnome-shell-extension.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 999 "gnome-shell-extension.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 179 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_vala1__error_ = _data_->_inner_error0_;
#line 179 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_inner_error0_ = NULL;
#line 183 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp11_ = _data_->_vala1__error_;
#line 183 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp12_ = _data_->_tmp11_->message;
#line 183 "../plugins/gnome/gnome-shell-extension.vala"
		g_warning ("gnome-shell-extension.vala:183: Error while updating extension state: " \
"%s", _data_->_tmp12_);
#line 184 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp13_ = _data_->_vala1__error_;
#line 184 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp14_ = _g_error_copy0 (_data_->_tmp13_);
#line 184 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_inner_error0_ = _data_->_tmp14_;
#line 184 "../plugins/gnome/gnome-shell-extension.vala"
		_g_error_free0 (_data_->_vala1__error_);
#line 1024 "gnome-shell-extension.c"
		goto __finally1;
	}
	__finally1:
#line 179 "../plugins/gnome/gnome-shell-extension.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 179 "../plugins/gnome/gnome-shell-extension.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 179 "../plugins/gnome/gnome-shell-extension.vala"
		_g_hash_table_unref0 (_data_->data);
#line 179 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_unref (_data_->_async_result);
#line 179 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 1038 "gnome-shell-extension.c"
	}
#line 166 "../plugins/gnome/gnome-shell-extension.vala"
	_g_hash_table_unref0 (_data_->data);
#line 166 "../plugins/gnome/gnome-shell-extension.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 166 "../plugins/gnome/gnome-shell-extension.vala"
	if (_data_->_state_ != 0) {
#line 166 "../plugins/gnome/gnome-shell-extension.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 166 "../plugins/gnome/gnome-shell-extension.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1050 "gnome-shell-extension.c"
		}
	}
#line 166 "../plugins/gnome/gnome-shell-extension.vala"
	g_object_unref (_data_->_async_result);
#line 166 "../plugins/gnome/gnome-shell-extension.vala"
	return FALSE;
#line 1057 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_on_extension_state_changed (GnomePluginGnomeShellExtension* self,
                                                               const gchar* uuid,
                                                               GHashTable* data)
{
	const gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 188 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (self != NULL);
#line 188 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (uuid != NULL);
#line 188 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (data != NULL);
#line 191 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp0_ = self->priv->_uuid;
#line 191 "../plugins/gnome/gnome-shell-extension.vala"
	if (g_strcmp0 (uuid, _tmp0_) != 0) {
#line 192 "../plugins/gnome/gnome-shell-extension.vala"
		return;
#line 1079 "gnome-shell-extension.c"
	}
	{
#line 196 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_do_update (self, data, &_inner_error0_);
#line 196 "../plugins/gnome/gnome-shell-extension.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1086 "gnome-shell-extension.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 195 "../plugins/gnome/gnome-shell-extension.vala"
		_error_ = _inner_error0_;
#line 195 "../plugins/gnome/gnome-shell-extension.vala"
		_inner_error0_ = NULL;
#line 199 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp1_ = _error_;
#line 199 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp2_ = _tmp1_->message;
#line 199 "../plugins/gnome/gnome-shell-extension.vala"
		g_warning ("gnome-shell-extension.vala:199: %s", _tmp2_);
#line 195 "../plugins/gnome/gnome-shell-extension.vala"
		_g_error_free0 (_error_);
#line 1108 "gnome-shell-extension.c"
	}
	__finally0:
#line 195 "../plugins/gnome/gnome-shell-extension.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 195 "../plugins/gnome/gnome-shell-extension.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 195 "../plugins/gnome/gnome-shell-extension.vala"
		g_clear_error (&_inner_error0_);
#line 195 "../plugins/gnome/gnome-shell-extension.vala"
		return;
#line 1119 "gnome-shell-extension.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1545 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1546 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1142 "gnome-shell-extension.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1146 "gnome-shell-extension.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1152 "gnome-shell-extension.c"
	} else {
#line 1546 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1156 "gnome-shell-extension.c"
	}
#line 1546 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1160 "gnome-shell-extension.c"
		gchar* _tmp2_;
#line 1547 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1547 "glib-2.0.vapi"
		result = _tmp2_;
#line 1547 "glib-2.0.vapi"
		return result;
#line 1168 "gnome-shell-extension.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1550 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1550 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1550 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1550 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1550 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1550 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1550 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1550 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1196 "gnome-shell-extension.c"
				goto __catch0_g_regex_error;
			}
#line 1550 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1550 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
			return NULL;
#line 1205 "gnome-shell-extension.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1551 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1551 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1551 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1551 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1219 "gnome-shell-extension.c"
				goto __catch0_g_regex_error;
			}
#line 1551 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1551 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1551 "glib-2.0.vapi"
			return NULL;
#line 1228 "gnome-shell-extension.c"
		}
#line 1551 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1551 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1551 "glib-2.0.vapi"
		result = _tmp10_;
#line 1551 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1551 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1551 "glib-2.0.vapi"
		return result;
#line 1242 "gnome-shell-extension.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1549 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1553 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1251 "gnome-shell-extension.c"
	}
	__finally0:
#line 1549 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1549 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1549 "glib-2.0.vapi"
	return NULL;
#line 1260 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_eval_script (GnomePluginGnomeShellExtension* self,
                                                const gchar* script,
                                                GError** error)
{
	gboolean success = FALSE;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	GnomeShell* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_;
	gboolean _tmp8_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 203 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (self != NULL);
#line 203 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (script != NULL);
#line 205 "../plugins/gnome/gnome-shell-extension.vala"
	success = FALSE;
#line 206 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp0_ = g_strdup ("");
#line 206 "../plugins/gnome/gnome-shell-extension.vala"
	_result_ = _tmp0_;
#line 208 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp1_ = self->priv->shell_proxy;
#line 208 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp2_ = string_replace (GNOME_PLUGIN_SCRIPT_WRAPPER, "${SCRIPT}", script);
#line 208 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp3_ = _tmp2_;
#line 208 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_shell_eval (_tmp1_, _tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 208 "../plugins/gnome/gnome-shell-extension.vala"
	success = _tmp4_;
#line 208 "../plugins/gnome/gnome-shell-extension.vala"
	_g_free0 (_result_);
#line 208 "../plugins/gnome/gnome-shell-extension.vala"
	_result_ = _tmp5_;
#line 208 "../plugins/gnome/gnome-shell-extension.vala"
	_g_free0 (_tmp3_);
#line 208 "../plugins/gnome/gnome-shell-extension.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 208 "../plugins/gnome/gnome-shell-extension.vala"
		g_propagate_error (error, _inner_error0_);
#line 208 "../plugins/gnome/gnome-shell-extension.vala"
		_g_free0 (_result_);
#line 208 "../plugins/gnome/gnome-shell-extension.vala"
		return;
#line 1313 "gnome-shell-extension.c"
	}
#line 213 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp6_ = _result_;
#line 213 "../plugins/gnome/gnome-shell-extension.vala"
	if (g_strcmp0 (_tmp6_, "") != 0) {
#line 1319 "gnome-shell-extension.c"
		const gchar* _tmp7_;
#line 214 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp7_ = _result_;
#line 214 "../plugins/gnome/gnome-shell-extension.vala"
		g_debug ("gnome-shell-extension.vala:214: Eval result: %s", _tmp7_);
#line 1325 "gnome-shell-extension.c"
	}
#line 217 "../plugins/gnome/gnome-shell-extension.vala"
	if (success) {
#line 1329 "gnome-shell-extension.c"
		const gchar* _tmp9_;
#line 217 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp9_ = _result_;
#line 217 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp8_ = g_strcmp0 (_tmp9_, "null") == 0;
#line 1335 "gnome-shell-extension.c"
	} else {
#line 217 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp8_ = FALSE;
#line 1339 "gnome-shell-extension.c"
	}
#line 217 "../plugins/gnome/gnome-shell-extension.vala"
	if (_tmp8_) {
#line 1343 "gnome-shell-extension.c"
	} else {
		const gchar* _tmp10_;
		GError* _tmp11_;
#line 221 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp10_ = _result_;
#line 221 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp11_ = g_error_new_literal (GNOME_PLUGIN_GNOME_SHELL_EXTENSION_ERROR, GNOME_PLUGIN_GNOME_SHELL_EXTENSION_ERROR_EVAL_ERROR, _tmp10_);
#line 221 "../plugins/gnome/gnome-shell-extension.vala"
		_inner_error0_ = _tmp11_;
#line 221 "../plugins/gnome/gnome-shell-extension.vala"
		g_propagate_error (error, _inner_error0_);
#line 221 "../plugins/gnome/gnome-shell-extension.vala"
		_g_free0 (_result_);
#line 221 "../plugins/gnome/gnome-shell-extension.vala"
		return;
#line 1359 "gnome-shell-extension.c"
	}
#line 203 "../plugins/gnome/gnome-shell-extension.vala"
	_g_free0 (_result_);
#line 1363 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_load_data_free (gpointer _data)
{
	GnomePluginGnomeShellExtensionLoadData* _data_;
	_data_ = _data;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->self);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_slice_free (GnomePluginGnomeShellExtensionLoadData, _data_);
#line 1377 "gnome-shell-extension.c"
}

void
gnome_plugin_gnome_shell_extension_load (GnomePluginGnomeShellExtension* self,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	GnomePluginGnomeShellExtensionLoadData* _data_;
	GnomePluginGnomeShellExtension* _tmp0_;
	GCancellable* _tmp1_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (self != NULL);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = g_slice_new0 (GnomePluginGnomeShellExtensionLoadData);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gnome_plugin_gnome_shell_extension_load_data_free);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->self = _tmp0_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->cancellable = _tmp1_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_load_co (_data_);
#line 1409 "gnome-shell-extension.c"
}

gboolean
gnome_plugin_gnome_shell_extension_load_finish (GnomePluginGnomeShellExtension* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	gboolean result;
	GnomePluginGnomeShellExtensionLoadData* _data_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	if (NULL == _data_) {
#line 1423 "gnome-shell-extension.c"
		gboolean _tmp0_ = FALSE;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		return _tmp0_;
#line 1427 "gnome-shell-extension.c"
	}
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	result = _data_->result;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	return result;
#line 1433 "gnome-shell-extension.c"
}

/**
         * GNOME Shell is not aware of freshly installed extensions.
         * Extension normally would be visible after logging out.
         * This function tries to load the extension the same way GNOME Shell does it.
         */
static void
gnome_plugin_gnome_shell_extension_load_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	GnomePluginGnomeShellExtensionLoadData* _data_;
#line 241 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = _user_data_;
#line 241 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_source_object_ = source_object;
#line 241 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_res_ = _res_;
#line 241 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_load_co (_data_);
#line 1455 "gnome-shell-extension.c"
}

static gboolean
gnome_plugin_gnome_shell_extension_load_co (GnomePluginGnomeShellExtensionLoadData* _data_)
{
#line 230 "../plugins/gnome/gnome-shell-extension.vala"
	switch (_data_->_state_) {
#line 230 "../plugins/gnome/gnome-shell-extension.vala"
		case 0:
#line 1465 "gnome-shell-extension.c"
		goto _state_0;
#line 230 "../plugins/gnome/gnome-shell-extension.vala"
		case 1:
#line 1469 "gnome-shell-extension.c"
		goto _state_1;
		default:
#line 230 "../plugins/gnome/gnome-shell-extension.vala"
		g_assert_not_reached ();
#line 1474 "gnome-shell-extension.c"
	}
	_state_0:
#line 232 "../plugins/gnome/gnome-shell-extension.vala"
	if (_data_->cancellable != NULL) {
#line 232 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp0_ = g_cancellable_is_cancelled (_data_->cancellable);
#line 1481 "gnome-shell-extension.c"
	} else {
#line 232 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp0_ = FALSE;
#line 1485 "gnome-shell-extension.c"
	}
#line 232 "../plugins/gnome/gnome-shell-extension.vala"
	if (_data_->_tmp0_) {
#line 233 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->result = FALSE;
#line 233 "../plugins/gnome/gnome-shell-extension.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 233 "../plugins/gnome/gnome-shell-extension.vala"
		if (_data_->_state_ != 0) {
#line 233 "../plugins/gnome/gnome-shell-extension.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 233 "../plugins/gnome/gnome-shell-extension.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1499 "gnome-shell-extension.c"
			}
		}
#line 233 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_unref (_data_->_async_result);
#line 233 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 1506 "gnome-shell-extension.c"
	}
#line 236 "../plugins/gnome/gnome-shell-extension.vala"
	g_debug ("gnome-shell-extension.vala:236: Loading extension…");
#line 1510 "gnome-shell-extension.c"
	{
#line 239 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp1_ = _data_->self->priv->_uuid;
#line 239 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp2_ = string_replace (GNOME_PLUGIN_LOAD_SCRIPT, "${UUID}", _data_->_tmp1_);
#line 239 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 239 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_eval_script (_data_->self, _data_->_tmp3_, &_data_->_inner_error0_);
#line 239 "../plugins/gnome/gnome-shell-extension.vala"
		_g_free0 (_data_->_tmp3_);
#line 239 "../plugins/gnome/gnome-shell-extension.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1524 "gnome-shell-extension.c"
			goto __catch0_g_error;
		}
#line 241 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_state_ = 1;
#line 241 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_update (_data_->self, _data_->cancellable, gnome_plugin_gnome_shell_extension_load_ready, _data_);
#line 241 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 1533 "gnome-shell-extension.c"
		_state_1:
#line 241 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_update_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 241 "../plugins/gnome/gnome-shell-extension.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1539 "gnome-shell-extension.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 237 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 237 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_inner_error0_ = NULL;
#line 244 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp4_ = _data_->_error_;
#line 244 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp5_ = _data_->_tmp4_->message;
#line 244 "../plugins/gnome/gnome-shell-extension.vala"
		g_warning ("gnome-shell-extension.vala:244: Failed to load extension: %s", _data_->_tmp5_);
#line 237 "../plugins/gnome/gnome-shell-extension.vala"
		_g_error_free0 (_data_->_error_);
#line 1558 "gnome-shell-extension.c"
	}
	__finally0:
#line 237 "../plugins/gnome/gnome-shell-extension.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 237 "../plugins/gnome/gnome-shell-extension.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 237 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_unref (_data_->_async_result);
#line 237 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 1569 "gnome-shell-extension.c"
	}
#line 247 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp6_ = _data_->self->priv->_state;
#line 247 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->result = _data_->_tmp6_ != GNOME_EXTENSION_STATE_UNINSTALLED;
#line 247 "../plugins/gnome/gnome-shell-extension.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 247 "../plugins/gnome/gnome-shell-extension.vala"
	if (_data_->_state_ != 0) {
#line 247 "../plugins/gnome/gnome-shell-extension.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 247 "../plugins/gnome/gnome-shell-extension.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1583 "gnome-shell-extension.c"
		}
	}
#line 247 "../plugins/gnome/gnome-shell-extension.vala"
	g_object_unref (_data_->_async_result);
#line 247 "../plugins/gnome/gnome-shell-extension.vala"
	return FALSE;
#line 1590 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_reload_data_free (gpointer _data)
{
	GnomePluginGnomeShellExtensionReloadData* _data_;
	_data_ = _data;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->self);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_slice_free (GnomePluginGnomeShellExtensionReloadData, _data_);
#line 1604 "gnome-shell-extension.c"
}

void
gnome_plugin_gnome_shell_extension_reload (GnomePluginGnomeShellExtension* self,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	GnomePluginGnomeShellExtensionReloadData* _data_;
	GnomePluginGnomeShellExtension* _tmp0_;
	GCancellable* _tmp1_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (self != NULL);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = g_slice_new0 (GnomePluginGnomeShellExtensionReloadData);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gnome_plugin_gnome_shell_extension_reload_data_free);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->self = _tmp0_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->cancellable = _tmp1_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_reload_co (_data_);
#line 1636 "gnome-shell-extension.c"
}

gboolean
gnome_plugin_gnome_shell_extension_reload_finish (GnomePluginGnomeShellExtension* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	gboolean result;
	GnomePluginGnomeShellExtensionReloadData* _data_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	if (NULL == _data_) {
#line 1650 "gnome-shell-extension.c"
		gboolean _tmp0_ = FALSE;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		return _tmp0_;
#line 1654 "gnome-shell-extension.c"
	}
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	result = _data_->result;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	return result;
#line 1660 "gnome-shell-extension.c"
}

/**
         * Try reloading the extension.
         *
         * Old version of the extension might be loaded.
         */
static void
gnome_plugin_gnome_shell_extension_reload_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	GnomePluginGnomeShellExtensionReloadData* _data_;
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = _user_data_;
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_source_object_ = source_object;
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_res_ = _res_;
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_reload_co (_data_);
#line 1682 "gnome-shell-extension.c"
}

static gboolean
gnome_plugin_gnome_shell_extension_reload_co (GnomePluginGnomeShellExtensionReloadData* _data_)
{
#line 255 "../plugins/gnome/gnome-shell-extension.vala"
	switch (_data_->_state_) {
#line 255 "../plugins/gnome/gnome-shell-extension.vala"
		case 0:
#line 1692 "gnome-shell-extension.c"
		goto _state_0;
#line 255 "../plugins/gnome/gnome-shell-extension.vala"
		case 1:
#line 1696 "gnome-shell-extension.c"
		goto _state_1;
#line 255 "../plugins/gnome/gnome-shell-extension.vala"
		case 2:
#line 1700 "gnome-shell-extension.c"
		goto _state_2;
		default:
#line 255 "../plugins/gnome/gnome-shell-extension.vala"
		g_assert_not_reached ();
#line 1705 "gnome-shell-extension.c"
	}
	_state_0:
#line 257 "../plugins/gnome/gnome-shell-extension.vala"
	if (_data_->cancellable != NULL) {
#line 257 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp0_ = g_cancellable_is_cancelled (_data_->cancellable);
#line 1712 "gnome-shell-extension.c"
	} else {
#line 257 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp0_ = FALSE;
#line 1716 "gnome-shell-extension.c"
	}
#line 257 "../plugins/gnome/gnome-shell-extension.vala"
	if (_data_->_tmp0_) {
#line 258 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->result = FALSE;
#line 258 "../plugins/gnome/gnome-shell-extension.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 258 "../plugins/gnome/gnome-shell-extension.vala"
		if (_data_->_state_ != 0) {
#line 258 "../plugins/gnome/gnome-shell-extension.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 258 "../plugins/gnome/gnome-shell-extension.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1730 "gnome-shell-extension.c"
			}
		}
#line 258 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_unref (_data_->_async_result);
#line 258 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 1737 "gnome-shell-extension.c"
	}
#line 261 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp2_ = _data_->self->priv->_state;
#line 261 "../plugins/gnome/gnome-shell-extension.vala"
	if (_data_->_tmp2_ == GNOME_EXTENSION_STATE_UNINSTALLED) {
#line 261 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp1_ = TRUE;
#line 1745 "gnome-shell-extension.c"
	} else {
#line 261 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp3_ = _data_->self->priv->_path;
#line 261 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp1_ = g_strcmp0 (_data_->_tmp3_, "") == 0;
#line 1751 "gnome-shell-extension.c"
	}
#line 261 "../plugins/gnome/gnome-shell-extension.vala"
	if (_data_->_tmp1_) {
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_state_ = 1;
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_load (_data_->self, _data_->cancellable, gnome_plugin_gnome_shell_extension_reload_ready, _data_);
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 1761 "gnome-shell-extension.c"
		_state_1:
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp4_ = gnome_plugin_gnome_shell_extension_load_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
			g_object_unref (_data_->_async_result);
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
			return FALSE;
#line 1773 "gnome-shell-extension.c"
		}
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->result = _data_->_tmp4_;
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
		if (_data_->_state_ != 0) {
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1785 "gnome-shell-extension.c"
			}
		}
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_unref (_data_->_async_result);
#line 262 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 1792 "gnome-shell-extension.c"
	}
#line 265 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp5_ = _data_->self->priv->_path;
#line 265 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp6_ = g_strdup (_data_->_tmp5_);
#line 265 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->previous_path = _data_->_tmp6_;
#line 266 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp7_ = _data_->self->priv->_version;
#line 266 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp8_ = g_strdup (_data_->_tmp7_);
#line 266 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->previous_version = _data_->_tmp8_;
#line 268 "../plugins/gnome/gnome-shell-extension.vala"
	g_debug ("gnome-shell-extension.vala:268: Reloading extension…");
#line 1808 "gnome-shell-extension.c"
	{
#line 271 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp9_ = _data_->self->priv->_uuid;
#line 271 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp10_ = string_replace (GNOME_PLUGIN_RELOAD_SCRIPT, "${UUID}", _data_->_tmp9_);
#line 271 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 271 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_eval_script (_data_->self, _data_->_tmp11_, &_data_->_inner_error0_);
#line 271 "../plugins/gnome/gnome-shell-extension.vala"
		_g_free0 (_data_->_tmp11_);
#line 271 "../plugins/gnome/gnome-shell-extension.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1822 "gnome-shell-extension.c"
			goto __catch0_g_error;
		}
#line 273 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_state_ = 2;
#line 273 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_update (_data_->self, _data_->cancellable, gnome_plugin_gnome_shell_extension_reload_ready, _data_);
#line 273 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 1831 "gnome-shell-extension.c"
		_state_2:
#line 273 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_update_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 273 "../plugins/gnome/gnome-shell-extension.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1837 "gnome-shell-extension.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 269 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 269 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_inner_error0_ = NULL;
#line 276 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp12_ = _data_->_error_;
#line 276 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp13_ = _data_->_tmp12_->message;
#line 276 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp14_ = _data_->self->priv->_state;
#line 276 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp15_ = gnome_extension_state_to_string (_data_->_tmp14_);
#line 276 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 276 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp17_ = _data_->previous_path;
#line 276 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp18_ = _data_->previous_version;
#line 276 "../plugins/gnome/gnome-shell-extension.vala"
		g_warning ("gnome-shell-extension.vala:276: Failed to reload extension: %s, %s '%s" \
"' '%s'", _data_->_tmp13_, _data_->_tmp16_, _data_->_tmp17_, _data_->_tmp18_);
#line 276 "../plugins/gnome/gnome-shell-extension.vala"
		_g_free0 (_data_->_tmp16_);
#line 277 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp19_ = _data_->_error_;
#line 277 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp20_ = _data_->_tmp19_->message;
#line 277 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp21_ = g_error_new_literal (GNOME_PLUGIN_GNOME_SHELL_EXTENSION_ERROR, GNOME_PLUGIN_GNOME_SHELL_EXTENSION_ERROR_EVAL_ERROR, _data_->_tmp20_);
#line 277 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_inner_error0_ = _data_->_tmp21_;
#line 277 "../plugins/gnome/gnome-shell-extension.vala"
		_g_error_free0 (_data_->_error_);
#line 1876 "gnome-shell-extension.c"
		goto __finally0;
	}
	__finally0:
#line 269 "../plugins/gnome/gnome-shell-extension.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 269 "../plugins/gnome/gnome-shell-extension.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 269 "../plugins/gnome/gnome-shell-extension.vala"
		_g_free0 (_data_->previous_version);
#line 269 "../plugins/gnome/gnome-shell-extension.vala"
		_g_free0 (_data_->previous_path);
#line 269 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_unref (_data_->_async_result);
#line 269 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 1892 "gnome-shell-extension.c"
	}
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp23_ = _data_->self->priv->_path;
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp24_ = _data_->previous_path;
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
	if (g_strcmp0 (_data_->_tmp23_, _data_->_tmp24_) != 0) {
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp22_ = TRUE;
#line 1902 "gnome-shell-extension.c"
	} else {
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp25_ = _data_->self->priv->_version;
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp26_ = _data_->previous_version;
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp22_ = g_strcmp0 (_data_->_tmp25_, _data_->_tmp26_) != 0;
#line 1910 "gnome-shell-extension.c"
	}
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->result = _data_->_tmp22_;
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
	_g_free0 (_data_->previous_version);
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
	_g_free0 (_data_->previous_path);
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
	if (_data_->_state_ != 0) {
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1926 "gnome-shell-extension.c"
		}
	}
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
	g_object_unref (_data_->_async_result);
#line 280 "../plugins/gnome/gnome-shell-extension.vala"
	return FALSE;
#line 1933 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_enable_data_free (gpointer _data)
{
	GnomePluginGnomeShellExtensionEnableData* _data_;
	_data_ = _data;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->self);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_slice_free (GnomePluginGnomeShellExtensionEnableData, _data_);
#line 1947 "gnome-shell-extension.c"
}

void
gnome_plugin_gnome_shell_extension_enable (GnomePluginGnomeShellExtension* self,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	GnomePluginGnomeShellExtensionEnableData* _data_;
	GnomePluginGnomeShellExtension* _tmp0_;
	GCancellable* _tmp1_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (self != NULL);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = g_slice_new0 (GnomePluginGnomeShellExtensionEnableData);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gnome_plugin_gnome_shell_extension_enable_data_free);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->self = _tmp0_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->cancellable = _tmp1_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_enable_co (_data_);
#line 1979 "gnome-shell-extension.c"
}

gboolean
gnome_plugin_gnome_shell_extension_enable_finish (GnomePluginGnomeShellExtension* self,
                                                  GAsyncResult* _res_)
{
	gboolean result;
	GnomePluginGnomeShellExtensionEnableData* _data_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	if (NULL == _data_) {
#line 1992 "gnome-shell-extension.c"
		gboolean _tmp0_ = FALSE;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		return _tmp0_;
#line 1996 "gnome-shell-extension.c"
	}
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	result = _data_->result;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	return result;
#line 2002 "gnome-shell-extension.c"
}

/**
         * Try enabling the extension
         *
         * Will try loading the extension
         */
static void
gnome_plugin_gnome_shell_extension_enable_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	GnomePluginGnomeShellExtensionEnableData* _data_;
#line 292 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = _user_data_;
#line 292 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_source_object_ = source_object;
#line 292 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_res_ = _res_;
#line 292 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_enable_co (_data_);
#line 2024 "gnome-shell-extension.c"
}

static gboolean
gnome_plugin_gnome_shell_extension_enable_co (GnomePluginGnomeShellExtensionEnableData* _data_)
{
#line 288 "../plugins/gnome/gnome-shell-extension.vala"
	switch (_data_->_state_) {
#line 288 "../plugins/gnome/gnome-shell-extension.vala"
		case 0:
#line 2034 "gnome-shell-extension.c"
		goto _state_0;
#line 288 "../plugins/gnome/gnome-shell-extension.vala"
		case 1:
#line 2038 "gnome-shell-extension.c"
		goto _state_1;
#line 288 "../plugins/gnome/gnome-shell-extension.vala"
		case 2:
#line 2042 "gnome-shell-extension.c"
		goto _state_2;
#line 288 "../plugins/gnome/gnome-shell-extension.vala"
		case 3:
#line 2046 "gnome-shell-extension.c"
		goto _state_3;
		default:
#line 288 "../plugins/gnome/gnome-shell-extension.vala"
		g_assert_not_reached ();
#line 2051 "gnome-shell-extension.c"
	}
	_state_0:
#line 290 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp0_ = _data_->self->priv->_path;
#line 290 "../plugins/gnome/gnome-shell-extension.vala"
	if (g_strcmp0 (_data_->_tmp0_, "") == 0) {
#line 2058 "gnome-shell-extension.c"
		{
#line 292 "../plugins/gnome/gnome-shell-extension.vala"
			_data_->_state_ = 1;
#line 292 "../plugins/gnome/gnome-shell-extension.vala"
			gnome_plugin_gnome_shell_extension_load (_data_->self, NULL, gnome_plugin_gnome_shell_extension_enable_ready, _data_);
#line 292 "../plugins/gnome/gnome-shell-extension.vala"
			return FALSE;
#line 2066 "gnome-shell-extension.c"
			_state_1:
#line 292 "../plugins/gnome/gnome-shell-extension.vala"
			gnome_plugin_gnome_shell_extension_load_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 292 "../plugins/gnome/gnome-shell-extension.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2072 "gnome-shell-extension.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 291 "../plugins/gnome/gnome-shell-extension.vala"
			_data_->_error_ = _data_->_inner_error0_;
#line 291 "../plugins/gnome/gnome-shell-extension.vala"
			_data_->_inner_error0_ = NULL;
#line 295 "../plugins/gnome/gnome-shell-extension.vala"
			_data_->_tmp1_ = _data_->_error_;
#line 295 "../plugins/gnome/gnome-shell-extension.vala"
			_data_->_tmp2_ = _data_->_tmp1_->message;
#line 295 "../plugins/gnome/gnome-shell-extension.vala"
			g_warning ("gnome-shell-extension.vala:295: Error while loading extension: %s", _data_->_tmp2_);
#line 291 "../plugins/gnome/gnome-shell-extension.vala"
			_g_error_free0 (_data_->_error_);
#line 2091 "gnome-shell-extension.c"
		}
		__finally0:
#line 291 "../plugins/gnome/gnome-shell-extension.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 291 "../plugins/gnome/gnome-shell-extension.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 291 "../plugins/gnome/gnome-shell-extension.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 291 "../plugins/gnome/gnome-shell-extension.vala"
			g_object_unref (_data_->_async_result);
#line 291 "../plugins/gnome/gnome-shell-extension.vala"
			return FALSE;
#line 2104 "gnome-shell-extension.c"
		}
	}
#line 299 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp3_ = _data_->self->priv->shell_extensions_proxy;
#line 299 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp4_ = gnome_shell_extensions_get_user_extensions_enabled (_data_->_tmp3_);
#line 299 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 299 "../plugins/gnome/gnome-shell-extension.vala"
	if (!_data_->_tmp5_) {
#line 300 "../plugins/gnome/gnome-shell-extension.vala"
		g_warning ("gnome-shell-extension.vala:300: Extensions in GNOME Shell are currentl" \
"y disabled. Use Extensions app to enable extensions.");
#line 2117 "gnome-shell-extension.c"
	}
#line 303 "../plugins/gnome/gnome-shell-extension.vala"
	g_debug ("gnome-shell-extension.vala:303: Enabling extension…");
#line 2121 "gnome-shell-extension.c"
	{
#line 305 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp6_ = _data_->self->priv->shell_extensions_proxy;
#line 305 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp7_ = _data_->self->priv->_uuid;
#line 305 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_state_ = 2;
#line 305 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_shell_extensions_enable_extension (_data_->_tmp6_, _data_->_tmp7_, NULL, gnome_plugin_gnome_shell_extension_enable_ready, _data_);
#line 305 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 2133 "gnome-shell-extension.c"
		_state_2:
#line 305 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_shell_extensions_enable_extension_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 305 "../plugins/gnome/gnome-shell-extension.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2139 "gnome-shell-extension.c"
			goto __catch1_g_error;
		}
#line 307 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_state_ = 3;
#line 307 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_update (_data_->self, _data_->cancellable, gnome_plugin_gnome_shell_extension_enable_ready, _data_);
#line 307 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 2148 "gnome-shell-extension.c"
		_state_3:
#line 307 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_update_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 307 "../plugins/gnome/gnome-shell-extension.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2154 "gnome-shell-extension.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 304 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_vala1__error_ = _data_->_inner_error0_;
#line 304 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_inner_error0_ = NULL;
#line 310 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp8_ = _data_->_vala1__error_;
#line 310 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp9_ = _data_->_tmp8_->message;
#line 310 "../plugins/gnome/gnome-shell-extension.vala"
		g_warning ("gnome-shell-extension.vala:310: Error while enabling extension: %s", _data_->_tmp9_);
#line 304 "../plugins/gnome/gnome-shell-extension.vala"
		_g_error_free0 (_data_->_vala1__error_);
#line 2173 "gnome-shell-extension.c"
	}
	__finally1:
#line 304 "../plugins/gnome/gnome-shell-extension.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 304 "../plugins/gnome/gnome-shell-extension.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 304 "../plugins/gnome/gnome-shell-extension.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 304 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_unref (_data_->_async_result);
#line 304 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 2186 "gnome-shell-extension.c"
	}
#line 313 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp10_ = _data_->self->priv->_state;
#line 313 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->result = _data_->_tmp10_ == GNOME_EXTENSION_STATE_ENABLED;
#line 313 "../plugins/gnome/gnome-shell-extension.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 313 "../plugins/gnome/gnome-shell-extension.vala"
	if (_data_->_state_ != 0) {
#line 313 "../plugins/gnome/gnome-shell-extension.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 313 "../plugins/gnome/gnome-shell-extension.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2200 "gnome-shell-extension.c"
		}
	}
#line 313 "../plugins/gnome/gnome-shell-extension.vala"
	g_object_unref (_data_->_async_result);
#line 313 "../plugins/gnome/gnome-shell-extension.vala"
	return FALSE;
#line 2207 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_disable_data_free (gpointer _data)
{
	GnomePluginGnomeShellExtensionDisableData* _data_;
	_data_ = _data;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->self);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_slice_free (GnomePluginGnomeShellExtensionDisableData, _data_);
#line 2221 "gnome-shell-extension.c"
}

void
gnome_plugin_gnome_shell_extension_disable (GnomePluginGnomeShellExtension* self,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	GnomePluginGnomeShellExtensionDisableData* _data_;
	GnomePluginGnomeShellExtension* _tmp0_;
	GCancellable* _tmp1_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (self != NULL);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = g_slice_new0 (GnomePluginGnomeShellExtensionDisableData);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_task_set_task_data (_data_->_async_result, _data_, gnome_plugin_gnome_shell_extension_disable_data_free);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->self = _tmp0_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (_data_->cancellable);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->cancellable = _tmp1_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_disable_co (_data_);
#line 2253 "gnome-shell-extension.c"
}

gboolean
gnome_plugin_gnome_shell_extension_disable_finish (GnomePluginGnomeShellExtension* self,
                                                   GAsyncResult* _res_)
{
	gboolean result;
	GnomePluginGnomeShellExtensionDisableData* _data_;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	if (NULL == _data_) {
#line 2266 "gnome-shell-extension.c"
		gboolean _tmp0_ = FALSE;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		return _tmp0_;
#line 2270 "gnome-shell-extension.c"
	}
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	result = _data_->result;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	return result;
#line 2276 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_disable_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	GnomePluginGnomeShellExtensionDisableData* _data_;
#line 319 "../plugins/gnome/gnome-shell-extension.vala"
	_data_ = _user_data_;
#line 319 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_source_object_ = source_object;
#line 319 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_res_ = _res_;
#line 319 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_disable_co (_data_);
#line 2293 "gnome-shell-extension.c"
}

static gboolean
gnome_plugin_gnome_shell_extension_disable_co (GnomePluginGnomeShellExtensionDisableData* _data_)
{
#line 316 "../plugins/gnome/gnome-shell-extension.vala"
	switch (_data_->_state_) {
#line 316 "../plugins/gnome/gnome-shell-extension.vala"
		case 0:
#line 2303 "gnome-shell-extension.c"
		goto _state_0;
#line 316 "../plugins/gnome/gnome-shell-extension.vala"
		case 1:
#line 2307 "gnome-shell-extension.c"
		goto _state_1;
#line 316 "../plugins/gnome/gnome-shell-extension.vala"
		case 2:
#line 2311 "gnome-shell-extension.c"
		goto _state_2;
		default:
#line 316 "../plugins/gnome/gnome-shell-extension.vala"
		g_assert_not_reached ();
#line 2316 "gnome-shell-extension.c"
	}
	_state_0:
	{
#line 319 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp0_ = _data_->self->priv->shell_extensions_proxy;
#line 319 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp1_ = _data_->self->priv->_uuid;
#line 319 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_state_ = 1;
#line 319 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_shell_extensions_disable_extension (_data_->_tmp0_, _data_->_tmp1_, NULL, gnome_plugin_gnome_shell_extension_disable_ready, _data_);
#line 319 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 2330 "gnome-shell-extension.c"
		_state_1:
#line 319 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_shell_extensions_disable_extension_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
#line 319 "../plugins/gnome/gnome-shell-extension.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2336 "gnome-shell-extension.c"
			goto __catch0_g_error;
		}
#line 321 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_state_ = 2;
#line 321 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_update (_data_->self, _data_->cancellable, gnome_plugin_gnome_shell_extension_disable_ready, _data_);
#line 321 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 2345 "gnome-shell-extension.c"
		_state_2:
#line 321 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_update_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 321 "../plugins/gnome/gnome-shell-extension.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2351 "gnome-shell-extension.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 318 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 318 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_inner_error0_ = NULL;
#line 324 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp2_ = _data_->_error_;
#line 324 "../plugins/gnome/gnome-shell-extension.vala"
		_data_->_tmp3_ = _data_->_tmp2_->message;
#line 324 "../plugins/gnome/gnome-shell-extension.vala"
		g_warning ("gnome-shell-extension.vala:324: Error while disabling extension: %s", _data_->_tmp3_);
#line 318 "../plugins/gnome/gnome-shell-extension.vala"
		_g_error_free0 (_data_->_error_);
#line 2370 "gnome-shell-extension.c"
	}
	__finally0:
#line 318 "../plugins/gnome/gnome-shell-extension.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 318 "../plugins/gnome/gnome-shell-extension.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 318 "../plugins/gnome/gnome-shell-extension.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 318 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_unref (_data_->_async_result);
#line 318 "../plugins/gnome/gnome-shell-extension.vala"
		return FALSE;
#line 2383 "gnome-shell-extension.c"
	}
#line 327 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->_tmp4_ = _data_->self->priv->_state;
#line 327 "../plugins/gnome/gnome-shell-extension.vala"
	_data_->result = _data_->_tmp4_ != GNOME_EXTENSION_STATE_ENABLED;
#line 327 "../plugins/gnome/gnome-shell-extension.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 327 "../plugins/gnome/gnome-shell-extension.vala"
	if (_data_->_state_ != 0) {
#line 327 "../plugins/gnome/gnome-shell-extension.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 327 "../plugins/gnome/gnome-shell-extension.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2397 "gnome-shell-extension.c"
		}
	}
#line 327 "../plugins/gnome/gnome-shell-extension.vala"
	g_object_unref (_data_->_async_result);
#line 327 "../plugins/gnome/gnome-shell-extension.vala"
	return FALSE;
#line 2404 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_real_dispose (GObject* base)
{
	GnomePluginGnomeShellExtension * self;
	GApplication* _tmp1_;
#line 332 "../plugins/gnome/gnome-shell-extension.vala"
	self = (GnomePluginGnomeShellExtension*) base;
#line 334 "../plugins/gnome/gnome-shell-extension.vala"
	if (self->priv->extension_state_changed_id != ((gulong) 0)) {
#line 2416 "gnome-shell-extension.c"
		GnomeShellExtensions* _tmp0_;
#line 335 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp0_ = self->priv->shell_extensions_proxy;
#line 335 "../plugins/gnome/gnome-shell-extension.vala"
		g_signal_handler_disconnect ((GObject*) _tmp0_, self->priv->extension_state_changed_id);
#line 2422 "gnome-shell-extension.c"
	}
#line 338 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp1_ = g_application_get_default ();
#line 338 "../plugins/gnome/gnome-shell-extension.vala"
	g_application_withdraw_notification (_tmp1_, "extension");
#line 341 "../plugins/gnome/gnome-shell-extension.vala"
	G_OBJECT_CLASS (gnome_plugin_gnome_shell_extension_parent_class)->dispose (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject));
#line 2430 "gnome-shell-extension.c"
}

const gchar*
gnome_plugin_gnome_shell_extension_get_uuid (GnomePluginGnomeShellExtension* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 94 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp0_ = self->priv->_uuid;
#line 94 "../plugins/gnome/gnome-shell-extension.vala"
	result = _tmp0_;
#line 94 "../plugins/gnome/gnome-shell-extension.vala"
	return result;
#line 2446 "gnome-shell-extension.c"
}

void
gnome_plugin_gnome_shell_extension_set_uuid (GnomePluginGnomeShellExtension* self,
                                             const gchar* value)
{
	gchar* old_value;
#line 94 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (self != NULL);
#line 94 "../plugins/gnome/gnome-shell-extension.vala"
	old_value = gnome_plugin_gnome_shell_extension_get_uuid (self);
#line 94 "../plugins/gnome/gnome-shell-extension.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2460 "gnome-shell-extension.c"
		gchar* _tmp0_;
#line 94 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp0_ = g_strdup (value);
#line 94 "../plugins/gnome/gnome-shell-extension.vala"
		_g_free0 (self->priv->_uuid);
#line 94 "../plugins/gnome/gnome-shell-extension.vala"
		self->priv->_uuid = _tmp0_;
#line 94 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_notify_by_pspec ((GObject *) self, gnome_plugin_gnome_shell_extension_properties[GNOME_PLUGIN_GNOME_SHELL_EXTENSION_UUID_PROPERTY]);
#line 2470 "gnome-shell-extension.c"
	}
}

const gchar*
gnome_plugin_gnome_shell_extension_get_path (GnomePluginGnomeShellExtension* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 95 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp0_ = self->priv->_path;
#line 95 "../plugins/gnome/gnome-shell-extension.vala"
	result = _tmp0_;
#line 95 "../plugins/gnome/gnome-shell-extension.vala"
	return result;
#line 2487 "gnome-shell-extension.c"
}

void
gnome_plugin_gnome_shell_extension_set_path (GnomePluginGnomeShellExtension* self,
                                             const gchar* value)
{
	gchar* old_value;
#line 95 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (self != NULL);
#line 95 "../plugins/gnome/gnome-shell-extension.vala"
	old_value = gnome_plugin_gnome_shell_extension_get_path (self);
#line 95 "../plugins/gnome/gnome-shell-extension.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2501 "gnome-shell-extension.c"
		gchar* _tmp0_;
#line 95 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp0_ = g_strdup (value);
#line 95 "../plugins/gnome/gnome-shell-extension.vala"
		_g_free0 (self->priv->_path);
#line 95 "../plugins/gnome/gnome-shell-extension.vala"
		self->priv->_path = _tmp0_;
#line 95 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_notify_by_pspec ((GObject *) self, gnome_plugin_gnome_shell_extension_properties[GNOME_PLUGIN_GNOME_SHELL_EXTENSION_PATH_PROPERTY]);
#line 2511 "gnome-shell-extension.c"
	}
}

const gchar*
gnome_plugin_gnome_shell_extension_get_version (GnomePluginGnomeShellExtension* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 96 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 96 "../plugins/gnome/gnome-shell-extension.vala"
	_tmp0_ = self->priv->_version;
#line 96 "../plugins/gnome/gnome-shell-extension.vala"
	result = _tmp0_;
#line 96 "../plugins/gnome/gnome-shell-extension.vala"
	return result;
#line 2528 "gnome-shell-extension.c"
}

void
gnome_plugin_gnome_shell_extension_set_version (GnomePluginGnomeShellExtension* self,
                                                const gchar* value)
{
	gchar* old_value;
#line 96 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (self != NULL);
#line 96 "../plugins/gnome/gnome-shell-extension.vala"
	old_value = gnome_plugin_gnome_shell_extension_get_version (self);
#line 96 "../plugins/gnome/gnome-shell-extension.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2542 "gnome-shell-extension.c"
		gchar* _tmp0_;
#line 96 "../plugins/gnome/gnome-shell-extension.vala"
		_tmp0_ = g_strdup (value);
#line 96 "../plugins/gnome/gnome-shell-extension.vala"
		_g_free0 (self->priv->_version);
#line 96 "../plugins/gnome/gnome-shell-extension.vala"
		self->priv->_version = _tmp0_;
#line 96 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_notify_by_pspec ((GObject *) self, gnome_plugin_gnome_shell_extension_properties[GNOME_PLUGIN_GNOME_SHELL_EXTENSION_VERSION_PROPERTY]);
#line 2552 "gnome-shell-extension.c"
	}
}

GnomeExtensionState
gnome_plugin_gnome_shell_extension_get_state (GnomePluginGnomeShellExtension* self)
{
	GnomeExtensionState result;
#line 97 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 97 "../plugins/gnome/gnome-shell-extension.vala"
	result = self->priv->_state;
#line 97 "../plugins/gnome/gnome-shell-extension.vala"
	return result;
#line 2566 "gnome-shell-extension.c"
}

void
gnome_plugin_gnome_shell_extension_set_state (GnomePluginGnomeShellExtension* self,
                                              GnomeExtensionState value)
{
	GnomeExtensionState old_value;
#line 97 "../plugins/gnome/gnome-shell-extension.vala"
	g_return_if_fail (self != NULL);
#line 97 "../plugins/gnome/gnome-shell-extension.vala"
	old_value = gnome_plugin_gnome_shell_extension_get_state (self);
#line 97 "../plugins/gnome/gnome-shell-extension.vala"
	if (old_value != value) {
#line 97 "../plugins/gnome/gnome-shell-extension.vala"
		self->priv->_state = value;
#line 97 "../plugins/gnome/gnome-shell-extension.vala"
		g_object_notify_by_pspec ((GObject *) self, gnome_plugin_gnome_shell_extension_properties[GNOME_PLUGIN_GNOME_SHELL_EXTENSION_STATE_PROPERTY]);
#line 2584 "gnome-shell-extension.c"
	}
}

static void
gnome_plugin_gnome_shell_extension_class_init (GnomePluginGnomeShellExtensionClass * klass,
                                               gpointer klass_data)
{
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_parent_class = g_type_class_peek_parent (klass);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_type_class_adjust_private_offset (klass, &GnomePluginGnomeShellExtension_private_offset);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	((GnomePluginGnomeShellExtensionClass *) klass)->init_async = (void (*) (GnomePluginGnomeShellExtension*, gint, GCancellable*, GAsyncReadyCallback, gpointer)) gnome_plugin_gnome_shell_extension_real_init_async;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	((GnomePluginGnomeShellExtensionClass *) klass)->init_finish = (gboolean (*) (GnomePluginGnomeShellExtension*, GAsyncResult*, GError**)) gnome_plugin_gnome_shell_extension_real_init_finish;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) gnome_plugin_gnome_shell_extension_real_dispose;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gnome_plugin_gnome_shell_extension_get_property;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gnome_plugin_gnome_shell_extension_set_property;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	G_OBJECT_CLASS (klass)->finalize = gnome_plugin_gnome_shell_extension_finalize;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOME_PLUGIN_GNOME_SHELL_EXTENSION_UUID_PROPERTY, gnome_plugin_gnome_shell_extension_properties[GNOME_PLUGIN_GNOME_SHELL_EXTENSION_UUID_PROPERTY] = g_param_spec_string ("uuid", "uuid", "uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOME_PLUGIN_GNOME_SHELL_EXTENSION_PATH_PROPERTY, gnome_plugin_gnome_shell_extension_properties[GNOME_PLUGIN_GNOME_SHELL_EXTENSION_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOME_PLUGIN_GNOME_SHELL_EXTENSION_VERSION_PROPERTY, gnome_plugin_gnome_shell_extension_properties[GNOME_PLUGIN_GNOME_SHELL_EXTENSION_VERSION_PROPERTY] = g_param_spec_string ("version", "version", "version", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GNOME_PLUGIN_GNOME_SHELL_EXTENSION_STATE_PROPERTY, gnome_plugin_gnome_shell_extension_properties[GNOME_PLUGIN_GNOME_SHELL_EXTENSION_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", GNOME_TYPE_EXTENSION_STATE, GNOME_EXTENSION_STATE_UNINSTALLED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_signals[GNOME_PLUGIN_GNOME_SHELL_EXTENSION_STATE_CHANGED_SIGNAL] = g_signal_new ("state-changed", GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2618 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_g_async_initable_interface_init (GAsyncInitableIface * iface,
                                                                    gpointer iface_data)
{
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	gnome_plugin_gnome_shell_extension_g_async_initable_parent_iface = g_type_interface_peek_parent (iface);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	iface->init_async = (void (*) (GAsyncInitable*, gint, GCancellable*, GAsyncReadyCallback, gpointer)) gnome_plugin_gnome_shell_extension_init_async;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	iface->init_finish = (gboolean (*) (GAsyncInitable*, GAsyncResult*, GError**)) gnome_plugin_gnome_shell_extension_init_finish;
#line 2631 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_instance_init (GnomePluginGnomeShellExtension * self,
                                                  gpointer klass)
{
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	self->priv = gnome_plugin_gnome_shell_extension_get_instance_private (self);
#line 97 "../plugins/gnome/gnome-shell-extension.vala"
	self->priv->_state = GNOME_EXTENSION_STATE_UNINSTALLED;
#line 101 "../plugins/gnome/gnome-shell-extension.vala"
	self->priv->extension_state_changed_id = (gulong) 0;
#line 2644 "gnome-shell-extension.c"
}

static void
gnome_plugin_gnome_shell_extension_finalize (GObject * obj)
{
	GnomePluginGnomeShellExtension * self;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION, GnomePluginGnomeShellExtension);
#line 94 "../plugins/gnome/gnome-shell-extension.vala"
	_g_free0 (self->priv->_uuid);
#line 95 "../plugins/gnome/gnome-shell-extension.vala"
	_g_free0 (self->priv->_path);
#line 96 "../plugins/gnome/gnome-shell-extension.vala"
	_g_free0 (self->priv->_version);
#line 99 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (self->priv->shell_proxy);
#line 100 "../plugins/gnome/gnome-shell-extension.vala"
	_g_object_unref0 (self->priv->shell_extensions_proxy);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	G_OBJECT_CLASS (gnome_plugin_gnome_shell_extension_parent_class)->finalize (obj);
#line 2665 "gnome-shell-extension.c"
}

GType
gnome_plugin_gnome_shell_extension_get_type (void)
{
	return gnome_plugin_gnome_shell_extension_type_id;
}

GType
gnome_plugin_gnome_shell_extension_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnomePluginGnomeShellExtensionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnome_plugin_gnome_shell_extension_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomePluginGnomeShellExtension), 0, (GInstanceInitFunc) gnome_plugin_gnome_shell_extension_instance_init, NULL };
	static const GInterfaceInfo g_async_initable_info = { (GInterfaceInitFunc) gnome_plugin_gnome_shell_extension_g_async_initable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	gnome_plugin_gnome_shell_extension_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "GnomePluginGnomeShellExtension", &g_define_type_info, 0);
	g_type_module_add_interface (module, gnome_plugin_gnome_shell_extension_type_id, g_async_initable_get_type (), &g_async_initable_info);
	GnomePluginGnomeShellExtension_private_offset = sizeof (GnomePluginGnomeShellExtensionPrivate);
	return gnome_plugin_gnome_shell_extension_type_id;
}

static void
_vala_gnome_plugin_gnome_shell_extension_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec)
{
	GnomePluginGnomeShellExtension * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION, GnomePluginGnomeShellExtension);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	switch (property_id) {
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		case GNOME_PLUGIN_GNOME_SHELL_EXTENSION_UUID_PROPERTY:
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		g_value_set_string (value, gnome_plugin_gnome_shell_extension_get_uuid (self));
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		break;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		case GNOME_PLUGIN_GNOME_SHELL_EXTENSION_PATH_PROPERTY:
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		g_value_set_string (value, gnome_plugin_gnome_shell_extension_get_path (self));
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		break;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		case GNOME_PLUGIN_GNOME_SHELL_EXTENSION_VERSION_PROPERTY:
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		g_value_set_string (value, gnome_plugin_gnome_shell_extension_get_version (self));
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		break;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		case GNOME_PLUGIN_GNOME_SHELL_EXTENSION_STATE_PROPERTY:
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		g_value_set_enum (value, gnome_plugin_gnome_shell_extension_get_state (self));
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		break;
#line 2719 "gnome-shell-extension.c"
		default:
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		break;
#line 2725 "gnome-shell-extension.c"
	}
}

static void
_vala_gnome_plugin_gnome_shell_extension_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec)
{
	GnomePluginGnomeShellExtension * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GNOME_PLUGIN_TYPE_GNOME_SHELL_EXTENSION, GnomePluginGnomeShellExtension);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
	switch (property_id) {
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		case GNOME_PLUGIN_GNOME_SHELL_EXTENSION_UUID_PROPERTY:
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_set_uuid (self, g_value_get_string (value));
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		break;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		case GNOME_PLUGIN_GNOME_SHELL_EXTENSION_PATH_PROPERTY:
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_set_path (self, g_value_get_string (value));
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		break;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		case GNOME_PLUGIN_GNOME_SHELL_EXTENSION_VERSION_PROPERTY:
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_set_version (self, g_value_get_string (value));
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		break;
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		case GNOME_PLUGIN_GNOME_SHELL_EXTENSION_STATE_PROPERTY:
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		gnome_plugin_gnome_shell_extension_set_state (self, g_value_get_enum (value));
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		break;
#line 2763 "gnome-shell-extension.c"
		default:
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 92 "../plugins/gnome/gnome-shell-extension.vala"
		break;
#line 2769 "gnome-shell-extension.c"
	}
}

