/* notifications-capability.c generated by valac 0.56.14, the Vala compiler
 * generated from notifications-capability.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "gnome-pomodoro.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <config.h>
#include <math.h>
#include <float.h>

typedef GDBusProxy FreedesktopNotificationsProxy;
typedef GDBusProxyClass FreedesktopNotificationsProxyClass;
enum  {
	POMODORO_NOTIFICATIONS_CAPABILITY_0_PROPERTY,
	POMODORO_NOTIFICATIONS_CAPABILITY_NUM_PROPERTIES
};
static GParamSpec* pomodoro_notifications_capability_properties[POMODORO_NOTIFICATIONS_CAPABILITY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _PomodoroNotificationsCapabilityPrivate {
	GSettings* settings;
	PomodoroTimer* timer;
	PomodoroScreenNotification* screen_notification;
	FreedesktopNotifications* proxy;
	gboolean have_actions;
	gboolean have_persistence;
};

static gint PomodoroNotificationsCapability_private_offset;
static gpointer pomodoro_notifications_capability_parent_class = NULL;

static GType freedesktop_notifications_get_type_once (void);
static void freedesktop_notifications_proxy_g_signal (GDBusProxy* proxy,
                                               const gchar* sender_name,
                                               const gchar* signal_name,
                                               GVariant* parameters);
static void freedesktop_notifications_proxy_get_capabilities (FreedesktopNotifications* self,
                                                       gchar*** capabilities,
                                                       gint* capabilities_length1,
                                                       GError** error);
static void freedesktop_notifications_proxy_freedesktop_notifications_interface_init (FreedesktopNotificationsIface* iface);
static void _dbus_freedesktop_notifications_get_capabilities (FreedesktopNotifications* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation);
static void freedesktop_notifications_dbus_interface_method_call (GDBusConnection* connection,
                                                           const gchar* sender,
                                                           const gchar* object_path,
                                                           const gchar* interface_name,
                                                           const gchar* method_name,
                                                           GVariant* parameters,
                                                           GDBusMethodInvocation* invocation,
                                                           gpointer user_data);
static GVariant* freedesktop_notifications_dbus_interface_get_property (GDBusConnection* connection,
                                                                 const gchar* sender,
                                                                 const gchar* object_path,
                                                                 const gchar* interface_name,
                                                                 const gchar* property_name,
                                                                 GError** error,
                                                                 gpointer user_data);
static gboolean freedesktop_notifications_dbus_interface_set_property (GDBusConnection* connection,
                                                                const gchar* sender,
                                                                const gchar* object_path,
                                                                const gchar* interface_name,
                                                                const gchar* property_name,
                                                                GVariant* value,
                                                                GError** error,
                                                                gpointer user_data);
static void _freedesktop_notifications_unregister_object (gpointer user_data);
static void pomodoro_notifications_capability_notify_pomodoro_start (PomodoroNotificationsCapability* self);
static void pomodoro_notifications_capability_show_pomodoro_start_notification (PomodoroNotificationsCapability* self);
static void pomodoro_notifications_capability_notify_pomodoro_end (PomodoroNotificationsCapability* self);
static void pomodoro_notifications_capability_show_screen_notification (PomodoroNotificationsCapability* self);
static void pomodoro_notifications_capability_show_pomodoro_end_notification (PomodoroNotificationsCapability* self);
static void pomodoro_notifications_capability_withdraw_notifications (PomodoroNotificationsCapability* self);
static void ___lambda35_ (PomodoroNotificationsCapability* self);
static void ____lambda35__gtk_widget_destroy (GtkWidget* _sender,
                                       gpointer self);
static void pomodoro_notifications_capability_on_settings_changed (PomodoroNotificationsCapability* self,
                                                            GSettings* settings,
                                                            const gchar* key);
static void pomodoro_notifications_capability_on_timer_state_changed (PomodoroNotificationsCapability* self,
                                                               PomodoroTimerState* state,
                                                               PomodoroTimerState* previous_state);
static void pomodoro_notifications_capability_on_timer_state_duration_notify (PomodoroNotificationsCapability* self);
static void pomodoro_notifications_capability_on_timer_is_paused_notify (PomodoroNotificationsCapability* self);
static gboolean ___lambda36_ (PomodoroNotificationsCapability* self);
static gboolean ____lambda36__gsource_func (gpointer self);
static void pomodoro_notifications_capability_on_show_screen_notification_activate (PomodoroNotificationsCapability* self,
                                                                             GSimpleAction* action,
                                                                             GVariant* parameter);
static void pomodoro_notifications_capability_real_enable (PomodoroCapability* base);
static void _pomodoro_notifications_capability_on_show_screen_notification_activate_g_simple_action_activate (GSimpleAction* _sender,
                                                                                                       GVariant* parameter,
                                                                                                       gpointer self);
static void _pomodoro_notifications_capability_on_timer_state_changed_pomodoro_timer_state_changed (PomodoroTimer* _sender,
                                                                                             PomodoroTimerState* state,
                                                                                             PomodoroTimerState* previous_state,
                                                                                             gpointer self);
static void _pomodoro_notifications_capability_on_timer_state_duration_notify_g_object_notify (GObject* _sender,
                                                                                        GParamSpec* pspec,
                                                                                        gpointer self);
static void _pomodoro_notifications_capability_on_timer_is_paused_notify_g_object_notify (GObject* _sender,
                                                                                   GParamSpec* pspec,
                                                                                   gpointer self);
static void _pomodoro_notifications_capability_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                                                const gchar* key,
                                                                                gpointer self);
static void pomodoro_notifications_capability_real_disable (PomodoroCapability* base);
static GObject * pomodoro_notifications_capability_constructor (GType type,
                                                         guint n_construct_properties,
                                                         GObjectConstructParam * construct_properties);
static void pomodoro_notifications_capability_finalize (GObject * obj);
static GType pomodoro_notifications_capability_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GDBusArgInfo _freedesktop_notifications_dbus_arg_info_get_capabilities_capabilities = {-1, "capabilities", "as", NULL};
static const GDBusArgInfo * const _freedesktop_notifications_dbus_arg_info_get_capabilities_in[] = {NULL};
static const GDBusArgInfo * const _freedesktop_notifications_dbus_arg_info_get_capabilities_out[] = {&_freedesktop_notifications_dbus_arg_info_get_capabilities_capabilities, NULL};
static const GDBusMethodInfo _freedesktop_notifications_dbus_method_info_get_capabilities = {-1, "GetCapabilities", (GDBusArgInfo **) (&_freedesktop_notifications_dbus_arg_info_get_capabilities_in), (GDBusArgInfo **) (&_freedesktop_notifications_dbus_arg_info_get_capabilities_out), NULL};
static const GDBusMethodInfo * const _freedesktop_notifications_dbus_method_info[] = {&_freedesktop_notifications_dbus_method_info_get_capabilities, NULL};
static const GDBusSignalInfo * const _freedesktop_notifications_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _freedesktop_notifications_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _freedesktop_notifications_dbus_interface_info = {-1, "org.freedesktop.Notifications", (GDBusMethodInfo **) (&_freedesktop_notifications_dbus_method_info), (GDBusSignalInfo **) (&_freedesktop_notifications_dbus_signal_info), (GDBusPropertyInfo **) (&_freedesktop_notifications_dbus_property_info), NULL};
static const GDBusInterfaceVTable _freedesktop_notifications_dbus_interface_vtable = {freedesktop_notifications_dbus_interface_method_call, freedesktop_notifications_dbus_interface_get_property, freedesktop_notifications_dbus_interface_set_property};

void
freedesktop_notifications_get_capabilities (FreedesktopNotifications* self,
                                            gchar*** capabilities,
                                            gint* capabilities_length1,
                                            GError** error)
{
	FreedesktopNotificationsIface* _iface_;
#line 29 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/notifications-capability.vala"
	_iface_ = FREEDESKTOP_NOTIFICATIONS_GET_INTERFACE (self);
#line 29 "../src/notifications-capability.vala"
	if (_iface_->get_capabilities) {
#line 29 "../src/notifications-capability.vala"
		_iface_->get_capabilities (self, capabilities, capabilities_length1, error);
#line 181 "notifications-capability.c"
	}
}

static void
freedesktop_notifications_default_init (FreedesktopNotificationsIface * iface,
                                        gpointer iface_data)
{
}

static GType
freedesktop_notifications_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FreedesktopNotificationsIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) freedesktop_notifications_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType freedesktop_notifications_type_id;
	freedesktop_notifications_type_id = g_type_register_static (G_TYPE_INTERFACE, "FreedesktopNotifications", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (freedesktop_notifications_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (freedesktop_notifications_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) freedesktop_notifications_proxy_get_type);
	g_type_set_qdata (freedesktop_notifications_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.Notifications");
	g_type_set_qdata (freedesktop_notifications_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_freedesktop_notifications_dbus_interface_info));
	g_type_set_qdata (freedesktop_notifications_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) freedesktop_notifications_register_object);
	return freedesktop_notifications_type_id;
}

GType
freedesktop_notifications_get_type (void)
{
	static volatile gsize freedesktop_notifications_type_id__once = 0;
	if (g_once_init_enter (&freedesktop_notifications_type_id__once)) {
		GType freedesktop_notifications_type_id;
		freedesktop_notifications_type_id = freedesktop_notifications_get_type_once ();
		g_once_init_leave (&freedesktop_notifications_type_id__once, freedesktop_notifications_type_id);
	}
	return freedesktop_notifications_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (FreedesktopNotificationsProxy, freedesktop_notifications_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (FREEDESKTOP_TYPE_NOTIFICATIONS, freedesktop_notifications_proxy_freedesktop_notifications_interface_init) )
static void
freedesktop_notifications_proxy_class_init (FreedesktopNotificationsProxyClass* klass)
{
#line 29 "../src/aggregated-entry.vala"
	G_DBUS_PROXY_CLASS (klass)->g_signal = freedesktop_notifications_proxy_g_signal;
#line 223 "notifications-capability.c"
}

static void
freedesktop_notifications_proxy_g_signal (GDBusProxy* proxy,
                                          const gchar* sender_name,
                                          const gchar* signal_name,
                                          GVariant* parameters)
{
}

static void
freedesktop_notifications_proxy_init (FreedesktopNotificationsProxy* self)
{
#line 29 "../src/aggregated-entry.vala"
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_freedesktop_notifications_dbus_interface_info));
#line 239 "notifications-capability.c"
}

static void
freedesktop_notifications_proxy_get_capabilities (FreedesktopNotifications* self,
                                                  gchar*** capabilities,
                                                  gint* capabilities_length1,
                                                  GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar** _vala_capabilities = NULL;
	gint _vala_capabilities_length1;
	GVariant* _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length;
	gint _tmp7__size;
	gint _tmp7__length1;
	GVariantIter _tmp8_;
	GVariant* _tmp9_;
#line 29 "../src/aggregated-entry.vala"
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.Notifications", "GetCapabilities");
#line 29 "../src/aggregated-entry.vala"
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
#line 29 "../src/aggregated-entry.vala"
	_arguments = g_variant_builder_end (&_arguments_builder);
#line 29 "../src/aggregated-entry.vala"
	g_dbus_message_set_body (_message, _arguments);
#line 29 "../src/aggregated-entry.vala"
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
#line 29 "../src/aggregated-entry.vala"
	g_object_unref (_message);
#line 29 "../src/aggregated-entry.vala"
	if (!_reply_message) {
#line 29 "../src/aggregated-entry.vala"
		return;
#line 279 "notifications-capability.c"
	}
#line 29 "../src/aggregated-entry.vala"
	if (g_dbus_message_to_gerror (_reply_message, error)) {
#line 29 "../src/aggregated-entry.vala"
		g_object_unref (_reply_message);
#line 29 "../src/aggregated-entry.vala"
		return;
#line 287 "notifications-capability.c"
	}
#line 29 "../src/aggregated-entry.vala"
	_reply = g_dbus_message_get_body (_reply_message);
#line 29 "../src/aggregated-entry.vala"
	g_variant_iter_init (&_reply_iter, _reply);
#line 293 "notifications-capability.c"
	_vala_capabilities_length1 = 0;
#line 29 "../src/aggregated-entry.vala"
	_tmp6_ = g_variant_iter_next_value (&_reply_iter);
#line 297 "notifications-capability.c"
	_tmp7_ = g_new (gchar*, 5);
	_tmp7__length = 0;
	_tmp7__size = 4;
	_tmp7__length1 = 0;
#line 29 "../src/aggregated-entry.vala"
	g_variant_iter_init (&_tmp8_, _tmp6_);
#line 29 "../src/aggregated-entry.vala"
	for (; (_tmp9_ = g_variant_iter_next_value (&_tmp8_)) != NULL; _tmp7__length1++) {
#line 29 "../src/aggregated-entry.vala"
		if (_tmp7__size == _tmp7__length) {
#line 29 "../src/aggregated-entry.vala"
			_tmp7__size = 2 * _tmp7__size;
#line 29 "../src/aggregated-entry.vala"
			_tmp7_ = g_renew (gchar*, _tmp7_, _tmp7__size + 1);
#line 312 "notifications-capability.c"
		}
#line 29 "../src/aggregated-entry.vala"
		_tmp7_[_tmp7__length++] = g_variant_dup_string (_tmp9_, NULL);
#line 29 "../src/aggregated-entry.vala"
		g_variant_unref (_tmp9_);
#line 318 "notifications-capability.c"
	}
#line 29 "../src/aggregated-entry.vala"
	_vala_capabilities_length1 = _tmp7__length1;
#line 29 "../src/aggregated-entry.vala"
	_tmp7_[_tmp7__length] = NULL;
#line 29 "../src/aggregated-entry.vala"
	_vala_capabilities = _tmp7_;
#line 29 "../src/aggregated-entry.vala"
	g_variant_unref (_tmp6_);
#line 29 "../src/aggregated-entry.vala"
	*capabilities = _vala_capabilities;
#line 29 "../src/aggregated-entry.vala"
	*capabilities_length1 = _vala_capabilities_length1;
#line 29 "../src/aggregated-entry.vala"
	g_object_unref (_reply_message);
#line 334 "notifications-capability.c"
}

static void
freedesktop_notifications_proxy_freedesktop_notifications_interface_init (FreedesktopNotificationsIface* iface)
{
#line 29 "../src/aggregated-entry.vala"
	iface->get_capabilities = freedesktop_notifications_proxy_get_capabilities;
#line 342 "notifications-capability.c"
}

static void
_dbus_freedesktop_notifications_get_capabilities (FreedesktopNotifications* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar** capabilities = NULL;
	gint capabilities_length1 = 0;
	gchar** _tmp10_;
	GVariantBuilder _tmp11_;
	gint _tmp12_;
#line 29 "../src/aggregated-entry.vala"
	g_variant_iter_init (&_arguments_iter, _parameters_);
#line 29 "../src/aggregated-entry.vala"
	freedesktop_notifications_get_capabilities (self, &capabilities, &capabilities_length1, &error);
#line 29 "../src/aggregated-entry.vala"
	if (error) {
#line 29 "../src/aggregated-entry.vala"
		g_dbus_method_invocation_take_error (invocation, error);
#line 29 "../src/aggregated-entry.vala"
		return;
#line 370 "notifications-capability.c"
	}
#line 29 "../src/aggregated-entry.vala"
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
#line 29 "../src/aggregated-entry.vala"
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
#line 29 "../src/aggregated-entry.vala"
	_tmp10_ = capabilities;
#line 29 "../src/aggregated-entry.vala"
	g_variant_builder_init (&_tmp11_, G_VARIANT_TYPE ("as"));
#line 29 "../src/aggregated-entry.vala"
	for (_tmp12_ = 0; _tmp12_ < capabilities_length1; _tmp12_++) {
#line 29 "../src/aggregated-entry.vala"
		g_variant_builder_add_value (&_tmp11_, g_variant_new_string (*_tmp10_));
#line 29 "../src/aggregated-entry.vala"
		_tmp10_++;
#line 386 "notifications-capability.c"
	}
#line 29 "../src/aggregated-entry.vala"
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp11_));
#line 29 "../src/aggregated-entry.vala"
	_reply = g_variant_builder_end (&_reply_builder);
#line 29 "../src/aggregated-entry.vala"
	g_dbus_message_set_body (_reply_message, _reply);
#line 29 "../src/aggregated-entry.vala"
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
#line 29 "../src/aggregated-entry.vala"
	g_object_unref (invocation);
#line 29 "../src/aggregated-entry.vala"
	g_object_unref (_reply_message);
#line 29 "../src/aggregated-entry.vala"
	capabilities = (_vala_array_free (capabilities, capabilities_length1, (GDestroyNotify) g_free), NULL);
#line 402 "notifications-capability.c"
}

static void
freedesktop_notifications_dbus_interface_method_call (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* method_name,
                                                      GVariant* parameters,
                                                      GDBusMethodInvocation* invocation,
                                                      gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 29 "../src/aggregated-entry.vala"
	if (strcmp (method_name, "GetCapabilities") == 0) {
#line 29 "../src/aggregated-entry.vala"
		_dbus_freedesktop_notifications_get_capabilities (object, parameters, invocation);
#line 423 "notifications-capability.c"
	} else {
#line 29 "../src/aggregated-entry.vala"
		g_object_unref (invocation);
#line 427 "notifications-capability.c"
	}
}

static GVariant*
freedesktop_notifications_dbus_interface_get_property (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* property_name,
                                                       GError** error,
                                                       gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 29 "../src/aggregated-entry.vala"
	return NULL;
#line 446 "notifications-capability.c"
}

static gboolean
freedesktop_notifications_dbus_interface_set_property (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* property_name,
                                                       GVariant* value,
                                                       GError** error,
                                                       gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 29 "../src/aggregated-entry.vala"
	return FALSE;
#line 465 "notifications-capability.c"
}

guint
freedesktop_notifications_register_object (gpointer object,
                                           GDBusConnection* connection,
                                           const gchar* path,
                                           GError** error)
{
	guint result;
	gpointer *data;
#line 29 "../src/aggregated-entry.vala"
	data = g_new (gpointer, 3);
#line 29 "../src/aggregated-entry.vala"
	data[0] = g_object_ref (object);
#line 29 "../src/aggregated-entry.vala"
	data[1] = g_object_ref (connection);
#line 29 "../src/aggregated-entry.vala"
	data[2] = g_strdup (path);
#line 29 "../src/aggregated-entry.vala"
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_freedesktop_notifications_dbus_interface_info), &_freedesktop_notifications_dbus_interface_vtable, data, _freedesktop_notifications_unregister_object, error);
#line 29 "../src/aggregated-entry.vala"
	if (!result) {
#line 29 "../src/aggregated-entry.vala"
		return 0;
#line 490 "notifications-capability.c"
	}
#line 29 "../src/aggregated-entry.vala"
	return result;
#line 494 "notifications-capability.c"
}

static void
_freedesktop_notifications_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
#line 29 "../src/aggregated-entry.vala"
	g_object_unref (data[0]);
#line 29 "../src/aggregated-entry.vala"
	g_object_unref (data[1]);
#line 29 "../src/aggregated-entry.vala"
	g_free (data[2]);
#line 29 "../src/aggregated-entry.vala"
	g_free (data);
#line 510 "notifications-capability.c"
}

static inline gpointer
pomodoro_notifications_capability_get_instance_private (PomodoroNotificationsCapability* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroNotificationsCapability_private_offset);
}

PomodoroNotificationsCapability*
pomodoro_notifications_capability_construct (GType object_type,
                                             const gchar* name)
{
	PomodoroNotificationsCapability * self = NULL;
#line 74 "../src/notifications-capability.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 76 "../src/notifications-capability.vala"
	self = (PomodoroNotificationsCapability*) pomodoro_capability_construct (object_type, name, NULL, NULL, NULL, NULL, NULL, NULL);
#line 74 "../src/notifications-capability.vala"
	return self;
#line 530 "notifications-capability.c"
}

PomodoroNotificationsCapability*
pomodoro_notifications_capability_new (const gchar* name)
{
#line 74 "../src/notifications-capability.vala"
	return pomodoro_notifications_capability_construct (POMODORO_TYPE_NOTIFICATIONS_CAPABILITY, name);
#line 538 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_notify_pomodoro_start (PomodoroNotificationsCapability* self)
{
	PomodoroTimer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 79 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->timer;
#line 81 "../src/notifications-capability.vala"
	_tmp1_ = pomodoro_timer_get_is_paused (_tmp0_);
#line 81 "../src/notifications-capability.vala"
	_tmp2_ = _tmp1_;
#line 81 "../src/notifications-capability.vala"
	if (!_tmp2_) {
#line 82 "../src/notifications-capability.vala"
		pomodoro_notifications_capability_show_pomodoro_start_notification (self);
#line 559 "notifications-capability.c"
	}
}

static void
pomodoro_notifications_capability_notify_pomodoro_end (PomodoroNotificationsCapability* self)
{
	PomodoroTimer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 86 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->timer;
#line 88 "../src/notifications-capability.vala"
	_tmp1_ = pomodoro_timer_get_is_paused (_tmp0_);
#line 88 "../src/notifications-capability.vala"
	_tmp2_ = _tmp1_;
#line 88 "../src/notifications-capability.vala"
	if (!_tmp2_) {
#line 579 "notifications-capability.c"
		GSettings* _tmp3_;
#line 89 "../src/notifications-capability.vala"
		_tmp3_ = self->priv->settings;
#line 89 "../src/notifications-capability.vala"
		if (g_settings_get_boolean (_tmp3_, "show-screen-notifications")) {
#line 90 "../src/notifications-capability.vala"
			pomodoro_notifications_capability_show_screen_notification (self);
#line 587 "notifications-capability.c"
		} else {
#line 93 "../src/notifications-capability.vala"
			pomodoro_notifications_capability_show_pomodoro_end_notification (self);
#line 591 "notifications-capability.c"
		}
	}
}

static void
pomodoro_notifications_capability_withdraw_notifications (PomodoroNotificationsCapability* self)
{
	PomodoroScreenNotification* _tmp0_;
	GApplication* _tmp2_;
#line 98 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->screen_notification;
#line 100 "../src/notifications-capability.vala"
	if (_tmp0_ != NULL) {
#line 607 "notifications-capability.c"
		PomodoroScreenNotification* _tmp1_;
#line 101 "../src/notifications-capability.vala"
		_tmp1_ = self->priv->screen_notification;
#line 101 "../src/notifications-capability.vala"
		pomodoro_screen_notification_close (_tmp1_);
#line 613 "notifications-capability.c"
	}
#line 104 "../src/notifications-capability.vala"
	_tmp2_ = g_application_get_default ();
#line 104 "../src/notifications-capability.vala"
	g_application_withdraw_notification (_tmp2_, "timer");
#line 619 "notifications-capability.c"
}

static void
___lambda35_ (PomodoroNotificationsCapability* self)
{
	gboolean _tmp0_ = FALSE;
	PomodoroTimer* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 113 "../src/notifications-capability.vala"
	_g_object_unref0 (self->priv->screen_notification);
#line 113 "../src/notifications-capability.vala"
	self->priv->screen_notification = NULL;
#line 115 "../src/notifications-capability.vala"
	_tmp1_ = self->priv->timer;
#line 115 "../src/notifications-capability.vala"
	_tmp2_ = pomodoro_timer_get_is_paused (_tmp1_);
#line 115 "../src/notifications-capability.vala"
	_tmp3_ = _tmp2_;
#line 115 "../src/notifications-capability.vala"
	if (!_tmp3_) {
#line 641 "notifications-capability.c"
		PomodoroTimer* _tmp4_;
		PomodoroTimerState* _tmp5_;
		PomodoroTimerState* _tmp6_;
#line 115 "../src/notifications-capability.vala"
		_tmp4_ = self->priv->timer;
#line 115 "../src/notifications-capability.vala"
		_tmp5_ = pomodoro_timer_get_state (_tmp4_);
#line 115 "../src/notifications-capability.vala"
		_tmp6_ = _tmp5_;
#line 115 "../src/notifications-capability.vala"
		_tmp0_ = POMODORO_IS_BREAK_STATE (_tmp6_);
#line 653 "notifications-capability.c"
	} else {
#line 115 "../src/notifications-capability.vala"
		_tmp0_ = FALSE;
#line 657 "notifications-capability.c"
	}
#line 115 "../src/notifications-capability.vala"
	if (_tmp0_) {
#line 116 "../src/notifications-capability.vala"
		pomodoro_notifications_capability_show_pomodoro_end_notification (self);
#line 663 "notifications-capability.c"
	}
}

static void
____lambda35__gtk_widget_destroy (GtkWidget* _sender,
                                  gpointer self)
{
#line 112 "../src/notifications-capability.vala"
	___lambda35_ ((PomodoroNotificationsCapability*) self);
#line 673 "notifications-capability.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 121 "../src/notifications-capability.vala"
	return self ? g_object_ref (self) : NULL;
#line 681 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_show_screen_notification (PomodoroNotificationsCapability* self)
{
	PomodoroScreenNotification* _tmp0_;
	PomodoroApplication* application = NULL;
	PomodoroApplication* _tmp3_;
	PomodoroApplication* _tmp4_;
	PomodoroScreenNotification* _tmp5_;
	PomodoroScreenNotification* _tmp6_;
#line 108 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->screen_notification;
#line 110 "../src/notifications-capability.vala"
	if (_tmp0_ == NULL) {
#line 699 "notifications-capability.c"
		PomodoroScreenNotification* _tmp1_;
		PomodoroScreenNotification* _tmp2_;
#line 111 "../src/notifications-capability.vala"
		_tmp1_ = pomodoro_screen_notification_new ();
#line 111 "../src/notifications-capability.vala"
		g_object_ref_sink (_tmp1_);
#line 111 "../src/notifications-capability.vala"
		_g_object_unref0 (self->priv->screen_notification);
#line 111 "../src/notifications-capability.vala"
		self->priv->screen_notification = _tmp1_;
#line 112 "../src/notifications-capability.vala"
		_tmp2_ = self->priv->screen_notification;
#line 112 "../src/notifications-capability.vala"
		g_signal_connect_object ((GtkWidget*) _tmp2_, "destroy", (GCallback) ____lambda35__gtk_widget_destroy, self, 0);
#line 714 "notifications-capability.c"
	}
#line 121 "../src/notifications-capability.vala"
	_tmp3_ = pomodoro_application_get_default ();
#line 121 "../src/notifications-capability.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 121 "../src/notifications-capability.vala"
	application = _tmp4_;
#line 122 "../src/notifications-capability.vala"
	_tmp5_ = self->priv->screen_notification;
#line 122 "../src/notifications-capability.vala"
	gtk_application_add_window ((GtkApplication*) application, (GtkWindow*) _tmp5_);
#line 124 "../src/notifications-capability.vala"
	_tmp6_ = self->priv->screen_notification;
#line 124 "../src/notifications-capability.vala"
	gtk_window_present ((GtkWindow*) _tmp6_);
#line 108 "../src/notifications-capability.vala"
	_g_object_unref0 (application);
#line 732 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_show_pomodoro_start_notification (PomodoroNotificationsCapability* self)
{
	GNotification* notification = NULL;
	GNotification* _tmp0_;
	GApplication* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 127 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/notifications-capability.vala"
	_tmp0_ = g_notification_new (_ ("Pomodoro"));
#line 129 "../src/notifications-capability.vala"
	notification = _tmp0_;
#line 130 "../src/notifications-capability.vala"
	g_notification_set_body (notification, _ ("Focus on your task."));
#line 131 "../src/notifications-capability.vala"
	g_notification_set_priority (notification, G_NOTIFICATION_PRIORITY_HIGH);
#line 752 "notifications-capability.c"
	{
		GIcon* _tmp1_ = NULL;
		GIcon* _tmp2_;
#line 134 "../src/notifications-capability.vala"
		_tmp2_ = g_icon_new_for_string (PACKAGE_NAME, &_inner_error0_);
#line 134 "../src/notifications-capability.vala"
		_tmp1_ = _tmp2_;
#line 134 "../src/notifications-capability.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 762 "notifications-capability.c"
			goto __catch0_g_error;
		}
#line 134 "../src/notifications-capability.vala"
		g_notification_set_icon (notification, _tmp1_);
#line 133 "../src/notifications-capability.vala"
		_g_object_unref0 (_tmp1_);
#line 769 "notifications-capability.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 133 "../src/notifications-capability.vala"
		_error_ = _inner_error0_;
#line 133 "../src/notifications-capability.vala"
		_inner_error0_ = NULL;
#line 137 "../src/notifications-capability.vala"
		_tmp3_ = _error_;
#line 137 "../src/notifications-capability.vala"
		_tmp4_ = _tmp3_->message;
#line 137 "../src/notifications-capability.vala"
		g_warning ("notifications-capability.vala:137: %s", _tmp4_);
#line 133 "../src/notifications-capability.vala"
		_g_error_free0 (_error_);
#line 789 "notifications-capability.c"
	}
	__finally0:
#line 133 "../src/notifications-capability.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 133 "../src/notifications-capability.vala"
		_g_object_unref0 (notification);
#line 133 "../src/notifications-capability.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 133 "../src/notifications-capability.vala"
		g_clear_error (&_inner_error0_);
#line 133 "../src/notifications-capability.vala"
		return;
#line 802 "notifications-capability.c"
	}
#line 140 "../src/notifications-capability.vala"
	if (self->priv->have_actions) {
#line 141 "../src/notifications-capability.vala"
		g_notification_add_button (notification, _ ("Take a break"), "app.timer-skip");
#line 808 "notifications-capability.c"
	}
#line 144 "../src/notifications-capability.vala"
	_tmp5_ = g_application_get_default ();
#line 144 "../src/notifications-capability.vala"
	g_application_send_notification (_tmp5_, "timer", notification);
#line 127 "../src/notifications-capability.vala"
	_g_object_unref0 (notification);
#line 816 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_show_pomodoro_end_notification (PomodoroNotificationsCapability* self)
{
	gint remaining = 0;
	PomodoroTimer* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gint minutes = 0;
	gint seconds = 0;
	gchar* _tmp3_ = NULL;
	gchar* body = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	PomodoroTimer* _tmp8_;
	PomodoroTimerState* _tmp9_;
	PomodoroTimerState* _tmp10_;
	GNotification* notification = NULL;
	GNotification* _tmp11_;
	const gchar* _tmp12_;
	GApplication* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 148 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->timer;
#line 152 "../src/notifications-capability.vala"
	_tmp1_ = pomodoro_timer_get_remaining (_tmp0_);
#line 152 "../src/notifications-capability.vala"
	_tmp2_ = _tmp1_;
#line 152 "../src/notifications-capability.vala"
	remaining = (gint) ceil (_tmp2_);
#line 153 "../src/notifications-capability.vala"
	minutes = (gint) round (((gdouble) remaining) / 60.0);
#line 154 "../src/notifications-capability.vala"
	seconds = (gint) floor ((gdouble) (remaining % 60));
#line 155 "../src/notifications-capability.vala"
	if (remaining > 45) {
#line 856 "notifications-capability.c"
		gchar* _tmp4_;
#line 156 "../src/notifications-capability.vala"
		_tmp4_ = g_strdup_printf (ngettext ("You have %d minute", "You have %d minutes", (gulong) minutes), minutes);
#line 156 "../src/notifications-capability.vala"
		_g_free0 (_tmp3_);
#line 156 "../src/notifications-capability.vala"
		_tmp3_ = _tmp4_;
#line 864 "notifications-capability.c"
	} else {
		gchar* _tmp5_;
#line 158 "../src/notifications-capability.vala"
		_tmp5_ = g_strdup_printf (ngettext ("You have %d second", "You have %d seconds", (gulong) seconds), seconds);
#line 158 "../src/notifications-capability.vala"
		_g_free0 (_tmp3_);
#line 158 "../src/notifications-capability.vala"
		_tmp3_ = _tmp5_;
#line 873 "notifications-capability.c"
	}
#line 155 "../src/notifications-capability.vala"
	_tmp6_ = g_strdup (_tmp3_);
#line 155 "../src/notifications-capability.vala"
	body = _tmp6_;
#line 161 "../src/notifications-capability.vala"
	_tmp8_ = self->priv->timer;
#line 161 "../src/notifications-capability.vala"
	_tmp9_ = pomodoro_timer_get_state (_tmp8_);
#line 161 "../src/notifications-capability.vala"
	_tmp10_ = _tmp9_;
#line 161 "../src/notifications-capability.vala"
	if (POMODORO_IS_SHORT_BREAK_STATE (_tmp10_)) {
#line 162 "../src/notifications-capability.vala"
		_tmp7_ = _ ("Take a break");
#line 889 "notifications-capability.c"
	} else {
#line 163 "../src/notifications-capability.vala"
		_tmp7_ = _ ("Take a longer break");
#line 893 "notifications-capability.c"
	}
#line 161 "../src/notifications-capability.vala"
	_tmp11_ = g_notification_new (_tmp7_);
#line 161 "../src/notifications-capability.vala"
	notification = _tmp11_;
#line 164 "../src/notifications-capability.vala"
	_tmp12_ = body;
#line 164 "../src/notifications-capability.vala"
	g_notification_set_body (notification, _tmp12_);
#line 165 "../src/notifications-capability.vala"
	g_notification_set_priority (notification, G_NOTIFICATION_PRIORITY_HIGH);
#line 905 "notifications-capability.c"
	{
		GIcon* _tmp13_ = NULL;
		GIcon* _tmp14_;
#line 168 "../src/notifications-capability.vala"
		_tmp14_ = g_icon_new_for_string (PACKAGE_NAME, &_inner_error0_);
#line 168 "../src/notifications-capability.vala"
		_tmp13_ = _tmp14_;
#line 168 "../src/notifications-capability.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 915 "notifications-capability.c"
			goto __catch0_g_error;
		}
#line 168 "../src/notifications-capability.vala"
		g_notification_set_icon (notification, _tmp13_);
#line 167 "../src/notifications-capability.vala"
		_g_object_unref0 (_tmp13_);
#line 922 "notifications-capability.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 167 "../src/notifications-capability.vala"
		_error_ = _inner_error0_;
#line 167 "../src/notifications-capability.vala"
		_inner_error0_ = NULL;
#line 171 "../src/notifications-capability.vala"
		_tmp15_ = _error_;
#line 171 "../src/notifications-capability.vala"
		_tmp16_ = _tmp15_->message;
#line 171 "../src/notifications-capability.vala"
		g_warning ("notifications-capability.vala:171: %s", _tmp16_);
#line 167 "../src/notifications-capability.vala"
		_g_error_free0 (_error_);
#line 942 "notifications-capability.c"
	}
	__finally0:
#line 167 "../src/notifications-capability.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 167 "../src/notifications-capability.vala"
		_g_object_unref0 (notification);
#line 167 "../src/notifications-capability.vala"
		_g_free0 (body);
#line 167 "../src/notifications-capability.vala"
		_g_free0 (_tmp3_);
#line 167 "../src/notifications-capability.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 167 "../src/notifications-capability.vala"
		g_clear_error (&_inner_error0_);
#line 167 "../src/notifications-capability.vala"
		return;
#line 959 "notifications-capability.c"
	}
#line 174 "../src/notifications-capability.vala"
	if (self->priv->have_actions) {
#line 963 "notifications-capability.c"
		PomodoroTimer* _tmp17_;
		PomodoroTimerState* _tmp18_;
		PomodoroTimerState* _tmp19_;
		GVariant* _tmp24_;
		GVariant* _tmp25_;
#line 176 "../src/notifications-capability.vala"
		g_notification_set_default_action (notification, "app.show-screen-notification");
#line 178 "../src/notifications-capability.vala"
		_tmp17_ = self->priv->timer;
#line 178 "../src/notifications-capability.vala"
		_tmp18_ = pomodoro_timer_get_state (_tmp17_);
#line 178 "../src/notifications-capability.vala"
		_tmp19_ = _tmp18_;
#line 178 "../src/notifications-capability.vala"
		if (POMODORO_IS_SHORT_BREAK_STATE (_tmp19_)) {
#line 979 "notifications-capability.c"
			GVariant* _tmp20_;
			GVariant* _tmp21_;
#line 179 "../src/notifications-capability.vala"
			_tmp20_ = g_variant_new_string ("long-break");
#line 179 "../src/notifications-capability.vala"
			g_variant_ref_sink (_tmp20_);
#line 179 "../src/notifications-capability.vala"
			_tmp21_ = _tmp20_;
#line 179 "../src/notifications-capability.vala"
			g_notification_add_button_with_target_value (notification, _ ("Lengthen it"), "app.timer-switch-state", _tmp21_);
#line 179 "../src/notifications-capability.vala"
			_g_variant_unref0 (_tmp21_);
#line 992 "notifications-capability.c"
		} else {
			GVariant* _tmp22_;
			GVariant* _tmp23_;
#line 184 "../src/notifications-capability.vala"
			_tmp22_ = g_variant_new_string ("short-break");
#line 184 "../src/notifications-capability.vala"
			g_variant_ref_sink (_tmp22_);
#line 184 "../src/notifications-capability.vala"
			_tmp23_ = _tmp22_;
#line 184 "../src/notifications-capability.vala"
			g_notification_add_button_with_target_value (notification, _ ("Shorten it"), "app.timer-switch-state", _tmp23_);
#line 184 "../src/notifications-capability.vala"
			_g_variant_unref0 (_tmp23_);
#line 1006 "notifications-capability.c"
		}
#line 189 "../src/notifications-capability.vala"
		_tmp24_ = g_variant_new_string ("pomodoro");
#line 189 "../src/notifications-capability.vala"
		g_variant_ref_sink (_tmp24_);
#line 189 "../src/notifications-capability.vala"
		_tmp25_ = _tmp24_;
#line 189 "../src/notifications-capability.vala"
		g_notification_add_button_with_target_value (notification, _ ("Start pomodoro"), "app.timer-set-state", _tmp25_);
#line 189 "../src/notifications-capability.vala"
		_g_variant_unref0 (_tmp25_);
#line 1018 "notifications-capability.c"
	}
#line 194 "../src/notifications-capability.vala"
	_tmp26_ = g_application_get_default ();
#line 194 "../src/notifications-capability.vala"
	g_application_send_notification (_tmp26_, "timer", notification);
#line 148 "../src/notifications-capability.vala"
	_g_object_unref0 (notification);
#line 148 "../src/notifications-capability.vala"
	_g_free0 (body);
#line 148 "../src/notifications-capability.vala"
	_g_free0 (_tmp3_);
#line 1030 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_on_settings_changed (PomodoroNotificationsCapability* self,
                                                       GSettings* settings,
                                                       const gchar* key)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 201 "../src/notifications-capability.vala"
	static GQuark _tmp1_label0 = 0;
#line 198 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/notifications-capability.vala"
	g_return_if_fail (settings != NULL);
#line 198 "../src/notifications-capability.vala"
	g_return_if_fail (key != NULL);
#line 201 "../src/notifications-capability.vala"
	_tmp0_ = key;
#line 201 "../src/notifications-capability.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 201 "../src/notifications-capability.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("show-screen-notifications")))) {
#line 201 "../src/notifications-capability.vala"
		switch (0) {
#line 1056 "notifications-capability.c"
			default:
			{
				PomodoroTimer* _tmp3_;
				PomodoroTimerState* _tmp4_;
				PomodoroTimerState* _tmp5_;
#line 204 "../src/notifications-capability.vala"
				_tmp3_ = self->priv->timer;
#line 204 "../src/notifications-capability.vala"
				_tmp4_ = pomodoro_timer_get_state (_tmp3_);
#line 204 "../src/notifications-capability.vala"
				_tmp5_ = _tmp4_;
#line 204 "../src/notifications-capability.vala"
				if (POMODORO_IS_BREAK_STATE (_tmp5_)) {
#line 205 "../src/notifications-capability.vala"
					pomodoro_notifications_capability_notify_pomodoro_end (self);
#line 1072 "notifications-capability.c"
				}
#line 208 "../src/notifications-capability.vala"
				break;
#line 1076 "notifications-capability.c"
			}
		}
	}
}

static void
pomodoro_notifications_capability_on_timer_state_changed (PomodoroNotificationsCapability* self,
                                                          PomodoroTimerState* state,
                                                          PomodoroTimerState* previous_state)
{
#line 212 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 212 "../src/notifications-capability.vala"
	g_return_if_fail (state != NULL);
#line 212 "../src/notifications-capability.vala"
	g_return_if_fail (previous_state != NULL);
#line 215 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_withdraw_notifications (self);
#line 217 "../src/notifications-capability.vala"
	if (POMODORO_IS_POMODORO_STATE (state)) {
#line 218 "../src/notifications-capability.vala"
		pomodoro_notifications_capability_notify_pomodoro_start (self);
#line 1099 "notifications-capability.c"
	} else {
#line 220 "../src/notifications-capability.vala"
		if (POMODORO_IS_BREAK_STATE (state)) {
#line 221 "../src/notifications-capability.vala"
			pomodoro_notifications_capability_notify_pomodoro_end (self);
#line 1105 "notifications-capability.c"
		}
	}
}

static void
pomodoro_notifications_capability_on_timer_state_duration_notify (PomodoroNotificationsCapability* self)
{
	PomodoroTimer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 225 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 227 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->timer;
#line 227 "../src/notifications-capability.vala"
	_tmp1_ = pomodoro_timer_get_is_paused (_tmp0_);
#line 227 "../src/notifications-capability.vala"
	_tmp2_ = _tmp1_;
#line 227 "../src/notifications-capability.vala"
	if (!_tmp2_) {
#line 1126 "notifications-capability.c"
		PomodoroTimer* _tmp3_;
		PomodoroTimerState* _tmp4_;
		PomodoroTimerState* _tmp5_;
		PomodoroTimer* _tmp6_;
		PomodoroTimerState* _tmp7_;
		PomodoroTimerState* _tmp8_;
#line 228 "../src/notifications-capability.vala"
		_tmp3_ = self->priv->timer;
#line 228 "../src/notifications-capability.vala"
		_tmp4_ = pomodoro_timer_get_state (_tmp3_);
#line 228 "../src/notifications-capability.vala"
		_tmp5_ = _tmp4_;
#line 228 "../src/notifications-capability.vala"
		if (POMODORO_IS_POMODORO_STATE (_tmp5_)) {
#line 229 "../src/notifications-capability.vala"
			pomodoro_notifications_capability_show_pomodoro_start_notification (self);
#line 1143 "notifications-capability.c"
		}
#line 232 "../src/notifications-capability.vala"
		_tmp6_ = self->priv->timer;
#line 232 "../src/notifications-capability.vala"
		_tmp7_ = pomodoro_timer_get_state (_tmp6_);
#line 232 "../src/notifications-capability.vala"
		_tmp8_ = _tmp7_;
#line 232 "../src/notifications-capability.vala"
		if (POMODORO_IS_BREAK_STATE (_tmp8_)) {
#line 233 "../src/notifications-capability.vala"
			pomodoro_notifications_capability_show_pomodoro_end_notification (self);
#line 1155 "notifications-capability.c"
		}
	}
}

static gboolean
___lambda36_ (PomodoroNotificationsCapability* self)
{
	PomodoroTimer* _tmp0_;
	PomodoroTimerState* _tmp1_;
	PomodoroTimerState* _tmp2_;
	gboolean result;
#line 245 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->timer;
#line 245 "../src/notifications-capability.vala"
	_tmp1_ = pomodoro_timer_get_state (_tmp0_);
#line 245 "../src/notifications-capability.vala"
	_tmp2_ = _tmp1_;
#line 245 "../src/notifications-capability.vala"
	if (POMODORO_IS_POMODORO_STATE (_tmp2_)) {
#line 246 "../src/notifications-capability.vala"
		pomodoro_notifications_capability_notify_pomodoro_start (self);
#line 1177 "notifications-capability.c"
	} else {
		PomodoroTimer* _tmp3_;
		PomodoroTimerState* _tmp4_;
		PomodoroTimerState* _tmp5_;
#line 248 "../src/notifications-capability.vala"
		_tmp3_ = self->priv->timer;
#line 248 "../src/notifications-capability.vala"
		_tmp4_ = pomodoro_timer_get_state (_tmp3_);
#line 248 "../src/notifications-capability.vala"
		_tmp5_ = _tmp4_;
#line 248 "../src/notifications-capability.vala"
		if (POMODORO_IS_BREAK_STATE (_tmp5_)) {
#line 249 "../src/notifications-capability.vala"
			pomodoro_notifications_capability_notify_pomodoro_end (self);
#line 1192 "notifications-capability.c"
		}
	}
#line 252 "../src/notifications-capability.vala"
	result = G_SOURCE_REMOVE;
#line 252 "../src/notifications-capability.vala"
	return result;
#line 1199 "notifications-capability.c"
}

static gboolean
____lambda36__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda36_ ((PomodoroNotificationsCapability*) self);
#line 244 "../src/notifications-capability.vala"
	return result;
#line 1209 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_on_timer_is_paused_notify (PomodoroNotificationsCapability* self)
{
	PomodoroTimer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 238 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 240 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->timer;
#line 240 "../src/notifications-capability.vala"
	_tmp1_ = pomodoro_timer_get_is_paused (_tmp0_);
#line 240 "../src/notifications-capability.vala"
	_tmp2_ = _tmp1_;
#line 240 "../src/notifications-capability.vala"
	if (_tmp2_) {
#line 241 "../src/notifications-capability.vala"
		pomodoro_notifications_capability_withdraw_notifications (self);
#line 1230 "notifications-capability.c"
	} else {
#line 244 "../src/notifications-capability.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda36__gsource_func, g_object_ref (self), g_object_unref);
#line 1234 "notifications-capability.c"
	}
}

static void
pomodoro_notifications_capability_on_show_screen_notification_activate (PomodoroNotificationsCapability* self,
                                                                        GSimpleAction* action,
                                                                        GVariant* parameter)
{
#line 257 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/notifications-capability.vala"
	g_return_if_fail (action != NULL);
#line 260 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_show_screen_notification (self);
#line 1249 "notifications-capability.c"
}

static void
_pomodoro_notifications_capability_on_show_screen_notification_activate_g_simple_action_activate (GSimpleAction* _sender,
                                                                                                  GVariant* parameter,
                                                                                                  gpointer self)
{
#line 267 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_on_show_screen_notification_activate ((PomodoroNotificationsCapability*) self, _sender, parameter);
#line 1259 "notifications-capability.c"
}

static void
_pomodoro_notifications_capability_on_timer_state_changed_pomodoro_timer_state_changed (PomodoroTimer* _sender,
                                                                                        PomodoroTimerState* state,
                                                                                        PomodoroTimerState* previous_state,
                                                                                        gpointer self)
{
#line 273 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_on_timer_state_changed ((PomodoroNotificationsCapability*) self, state, previous_state);
#line 1270 "notifications-capability.c"
}

static void
_pomodoro_notifications_capability_on_timer_state_duration_notify_g_object_notify (GObject* _sender,
                                                                                   GParamSpec* pspec,
                                                                                   gpointer self)
{
#line 274 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_on_timer_state_duration_notify ((PomodoroNotificationsCapability*) self);
#line 1280 "notifications-capability.c"
}

static void
_pomodoro_notifications_capability_on_timer_is_paused_notify_g_object_notify (GObject* _sender,
                                                                              GParamSpec* pspec,
                                                                              gpointer self)
{
#line 275 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_on_timer_is_paused_notify ((PomodoroNotificationsCapability*) self);
#line 1290 "notifications-capability.c"
}

static void
_pomodoro_notifications_capability_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                                           const gchar* key,
                                                                           gpointer self)
{
#line 278 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_on_settings_changed ((PomodoroNotificationsCapability*) self, _sender, key);
#line 1300 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_real_enable (PomodoroCapability* base)
{
	PomodoroNotificationsCapability * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 263 "../src/notifications-capability.vala"
	self = (PomodoroNotificationsCapability*) base;
#line 265 "../src/notifications-capability.vala"
	_tmp0_ = pomodoro_capability_get_enabled ((PomodoroCapability*) self);
#line 265 "../src/notifications-capability.vala"
	_tmp1_ = _tmp0_;
#line 265 "../src/notifications-capability.vala"
	if (!_tmp1_) {
#line 1317 "notifications-capability.c"
		GSimpleAction* show_screen_notification_action = NULL;
		GSimpleAction* _tmp2_;
		GSimpleAction* _tmp3_;
		GApplication* application = NULL;
		GApplication* _tmp4_;
		GApplication* _tmp5_;
		GApplication* _tmp6_;
		GSimpleAction* _tmp7_;
		PomodoroTimer* _tmp8_;
		PomodoroTimer* _tmp9_;
		PomodoroTimer* _tmp10_;
		PomodoroTimer* _tmp11_;
		PomodoroTimer* _tmp12_;
		GSettings* _tmp13_;
		GSettings* _tmp14_;
		GSettings* _tmp15_;
		PomodoroTimer* _tmp16_;
		PomodoroTimerState* _tmp17_;
		PomodoroTimerState* _tmp18_;
		PomodoroTimer* _tmp19_;
		PomodoroTimerState* _tmp20_;
		PomodoroTimerState* _tmp21_;
#line 266 "../src/notifications-capability.vala"
		_tmp2_ = g_simple_action_new ("show-screen-notification", NULL);
#line 266 "../src/notifications-capability.vala"
		show_screen_notification_action = _tmp2_;
#line 267 "../src/notifications-capability.vala"
		_tmp3_ = show_screen_notification_action;
#line 267 "../src/notifications-capability.vala"
		g_signal_connect_object (_tmp3_, "activate", (GCallback) _pomodoro_notifications_capability_on_show_screen_notification_activate_g_simple_action_activate, self, 0);
#line 269 "../src/notifications-capability.vala"
		_tmp4_ = g_application_get_default ();
#line 269 "../src/notifications-capability.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 269 "../src/notifications-capability.vala"
		application = _tmp5_;
#line 270 "../src/notifications-capability.vala"
		_tmp6_ = application;
#line 270 "../src/notifications-capability.vala"
		_tmp7_ = show_screen_notification_action;
#line 270 "../src/notifications-capability.vala"
		g_action_map_add_action ((GActionMap*) _tmp6_, (GAction*) _tmp7_);
#line 272 "../src/notifications-capability.vala"
		_tmp8_ = pomodoro_timer_get_default ();
#line 272 "../src/notifications-capability.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 272 "../src/notifications-capability.vala"
		_g_object_unref0 (self->priv->timer);
#line 272 "../src/notifications-capability.vala"
		self->priv->timer = _tmp9_;
#line 273 "../src/notifications-capability.vala"
		_tmp10_ = self->priv->timer;
#line 273 "../src/notifications-capability.vala"
		g_signal_connect_object (_tmp10_, "state-changed", (GCallback) _pomodoro_notifications_capability_on_timer_state_changed_pomodoro_timer_state_changed, self, G_CONNECT_AFTER);
#line 274 "../src/notifications-capability.vala"
		_tmp11_ = self->priv->timer;
#line 274 "../src/notifications-capability.vala"
		g_signal_connect_object ((GObject*) _tmp11_, "notify::state-duration", (GCallback) _pomodoro_notifications_capability_on_timer_state_duration_notify_g_object_notify, self, 0);
#line 275 "../src/notifications-capability.vala"
		_tmp12_ = self->priv->timer;
#line 275 "../src/notifications-capability.vala"
		g_signal_connect_object ((GObject*) _tmp12_, "notify::is-paused", (GCallback) _pomodoro_notifications_capability_on_timer_is_paused_notify_g_object_notify, self, 0);
#line 277 "../src/notifications-capability.vala"
		_tmp13_ = pomodoro_get_settings ();
#line 277 "../src/notifications-capability.vala"
		_tmp14_ = g_settings_get_child (_tmp13_, "preferences");
#line 277 "../src/notifications-capability.vala"
		_g_object_unref0 (self->priv->settings);
#line 277 "../src/notifications-capability.vala"
		self->priv->settings = _tmp14_;
#line 278 "../src/notifications-capability.vala"
		_tmp15_ = self->priv->settings;
#line 278 "../src/notifications-capability.vala"
		g_signal_connect_object (_tmp15_, "changed", (GCallback) _pomodoro_notifications_capability_on_settings_changed_g_settings_changed, self, 0);
#line 280 "../src/notifications-capability.vala"
		_tmp16_ = self->priv->timer;
#line 280 "../src/notifications-capability.vala"
		_tmp17_ = pomodoro_timer_get_state (_tmp16_);
#line 280 "../src/notifications-capability.vala"
		_tmp18_ = _tmp17_;
#line 280 "../src/notifications-capability.vala"
		_tmp19_ = self->priv->timer;
#line 280 "../src/notifications-capability.vala"
		_tmp20_ = pomodoro_timer_get_state (_tmp19_);
#line 280 "../src/notifications-capability.vala"
		_tmp21_ = _tmp20_;
#line 280 "../src/notifications-capability.vala"
		pomodoro_notifications_capability_on_timer_state_changed (self, _tmp18_, _tmp21_);
#line 265 "../src/notifications-capability.vala"
		_g_object_unref0 (application);
#line 265 "../src/notifications-capability.vala"
		_g_object_unref0 (show_screen_notification_action);
#line 1410 "notifications-capability.c"
	}
#line 284 "../src/notifications-capability.vala"
	POMODORO_CAPABILITY_CLASS (pomodoro_notifications_capability_parent_class)->enable (G_TYPE_CHECK_INSTANCE_CAST (self, POMODORO_TYPE_CAPABILITY, PomodoroCapability));
#line 1414 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_real_disable (PomodoroCapability* base)
{
	PomodoroNotificationsCapability * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 287 "../src/notifications-capability.vala"
	self = (PomodoroNotificationsCapability*) base;
#line 289 "../src/notifications-capability.vala"
	_tmp0_ = pomodoro_capability_get_enabled ((PomodoroCapability*) self);
#line 289 "../src/notifications-capability.vala"
	_tmp1_ = _tmp0_;
#line 289 "../src/notifications-capability.vala"
	if (_tmp1_) {
#line 1431 "notifications-capability.c"
		PomodoroTimer* _tmp2_;
		guint _tmp3_;
		PomodoroTimer* _tmp4_;
		guint _tmp5_;
		GQuark _tmp6_;
		PomodoroTimer* _tmp7_;
		guint _tmp8_;
		GQuark _tmp9_;
		GSettings* _tmp10_;
		guint _tmp11_;
		GApplication* application = NULL;
		GApplication* _tmp12_;
		GApplication* _tmp13_;
		GApplication* _tmp14_;
#line 290 "../src/notifications-capability.vala"
		pomodoro_notifications_capability_withdraw_notifications (self);
#line 292 "../src/notifications-capability.vala"
		_tmp2_ = self->priv->timer;
#line 292 "../src/notifications-capability.vala"
		g_signal_parse_name ("state-changed", POMODORO_TYPE_TIMER, &_tmp3_, NULL, FALSE);
#line 292 "../src/notifications-capability.vala"
		g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _pomodoro_notifications_capability_on_timer_state_changed_pomodoro_timer_state_changed, self);
#line 293 "../src/notifications-capability.vala"
		_tmp4_ = self->priv->timer;
#line 293 "../src/notifications-capability.vala"
		g_signal_parse_name ("notify::state-duration", G_TYPE_OBJECT, &_tmp5_, &_tmp6_, TRUE);
#line 293 "../src/notifications-capability.vala"
		g_signal_handlers_disconnect_matched ((GObject*) _tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, _tmp6_, NULL, (GCallback) _pomodoro_notifications_capability_on_timer_state_duration_notify_g_object_notify, self);
#line 294 "../src/notifications-capability.vala"
		_tmp7_ = self->priv->timer;
#line 294 "../src/notifications-capability.vala"
		g_signal_parse_name ("notify::is-paused", G_TYPE_OBJECT, &_tmp8_, &_tmp9_, TRUE);
#line 294 "../src/notifications-capability.vala"
		g_signal_handlers_disconnect_matched ((GObject*) _tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, _tmp9_, NULL, (GCallback) _pomodoro_notifications_capability_on_timer_is_paused_notify_g_object_notify, self);
#line 295 "../src/notifications-capability.vala"
		_g_object_unref0 (self->priv->timer);
#line 295 "../src/notifications-capability.vala"
		self->priv->timer = NULL;
#line 297 "../src/notifications-capability.vala"
		_tmp10_ = self->priv->settings;
#line 297 "../src/notifications-capability.vala"
		g_signal_parse_name ("changed", g_settings_get_type (), &_tmp11_, NULL, FALSE);
#line 297 "../src/notifications-capability.vala"
		g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _pomodoro_notifications_capability_on_settings_changed_g_settings_changed, self);
#line 298 "../src/notifications-capability.vala"
		_g_object_unref0 (self->priv->settings);
#line 298 "../src/notifications-capability.vala"
		self->priv->settings = NULL;
#line 300 "../src/notifications-capability.vala"
		_tmp12_ = g_application_get_default ();
#line 300 "../src/notifications-capability.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 300 "../src/notifications-capability.vala"
		application = _tmp13_;
#line 301 "../src/notifications-capability.vala"
		_tmp14_ = application;
#line 301 "../src/notifications-capability.vala"
		g_action_map_remove_action ((GActionMap*) _tmp14_, "show-screen-notification");
#line 289 "../src/notifications-capability.vala"
		_g_object_unref0 (application);
#line 1492 "notifications-capability.c"
	}
#line 304 "../src/notifications-capability.vala"
	POMODORO_CAPABILITY_CLASS (pomodoro_notifications_capability_parent_class)->disable (G_TYPE_CHECK_INSTANCE_CAST (self, POMODORO_TYPE_CAPABILITY, PomodoroCapability));
#line 1496 "notifications-capability.c"
}

static GObject *
pomodoro_notifications_capability_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroNotificationsCapability * self;
	gchar** capabilities = NULL;
	gint capabilities_length1 = 0;
	gint _capabilities_size_ = 0;
	GError* _inner_error0_ = NULL;
#line 47 "../src/notifications-capability.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_notifications_capability_parent_class);
#line 47 "../src/notifications-capability.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 47 "../src/notifications-capability.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_NOTIFICATIONS_CAPABILITY, PomodoroNotificationsCapability);
#line 1517 "notifications-capability.c"
	{
		FreedesktopNotifications* _tmp0_ = NULL;
		FreedesktopNotifications* _tmp1_;
		FreedesktopNotifications* _tmp2_;
		FreedesktopNotifications* _tmp3_;
		gchar** _tmp4_ = NULL;
		gint _tmp5_ = 0;
#line 52 "../src/notifications-capability.vala"
		_tmp1_ = (FreedesktopNotifications*) g_initable_new (FREEDESKTOP_TYPE_NOTIFICATIONS_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_DO_NOT_AUTO_START, "g-name", "org.freedesktop.Notifications", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/freedesktop/Notifications", "g-interface-name", "org.freedesktop.Notifications", NULL);
#line 52 "../src/notifications-capability.vala"
		_tmp0_ = (FreedesktopNotifications*) _tmp1_;
#line 52 "../src/notifications-capability.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1531 "notifications-capability.c"
			goto __catch0_g_error;
		}
#line 52 "../src/notifications-capability.vala"
		_tmp2_ = _tmp0_;
#line 52 "../src/notifications-capability.vala"
		_tmp0_ = NULL;
#line 52 "../src/notifications-capability.vala"
		_g_object_unref0 (self->priv->proxy);
#line 52 "../src/notifications-capability.vala"
		self->priv->proxy = _tmp2_;
#line 56 "../src/notifications-capability.vala"
		_tmp3_ = self->priv->proxy;
#line 56 "../src/notifications-capability.vala"
		freedesktop_notifications_get_capabilities (_tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 56 "../src/notifications-capability.vala"
		capabilities = (_vala_array_free (capabilities, capabilities_length1, (GDestroyNotify) g_free), NULL);
#line 56 "../src/notifications-capability.vala"
		capabilities = _tmp4_;
#line 56 "../src/notifications-capability.vala"
		capabilities_length1 = _tmp5_;
#line 56 "../src/notifications-capability.vala"
		_capabilities_size_ = capabilities_length1;
#line 56 "../src/notifications-capability.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../src/notifications-capability.vala"
			_g_object_unref0 (_tmp0_);
#line 1558 "notifications-capability.c"
			goto __catch0_g_error;
		}
		{
			gint i = 0;
#line 58 "../src/notifications-capability.vala"
			i = 0;
#line 1565 "notifications-capability.c"
			{
				gboolean _tmp6_ = FALSE;
#line 58 "../src/notifications-capability.vala"
				_tmp6_ = TRUE;
#line 58 "../src/notifications-capability.vala"
				while (TRUE) {
#line 1572 "notifications-capability.c"
					gchar** _tmp8_;
					gint _tmp8__length1;
					gchar** _tmp9_;
					gint _tmp9__length1;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					GQuark _tmp13_ = 0U;
#line 59 "../src/notifications-capability.vala"
					static GQuark _tmp12_label0 = 0;
#line 59 "../src/notifications-capability.vala"
					static GQuark _tmp12_label1 = 0;
#line 58 "../src/notifications-capability.vala"
					if (!_tmp6_) {
#line 1586 "notifications-capability.c"
						gint _tmp7_;
#line 58 "../src/notifications-capability.vala"
						_tmp7_ = i;
#line 58 "../src/notifications-capability.vala"
						i = _tmp7_ + 1;
#line 1592 "notifications-capability.c"
					}
#line 58 "../src/notifications-capability.vala"
					_tmp6_ = FALSE;
#line 58 "../src/notifications-capability.vala"
					_tmp8_ = capabilities;
#line 58 "../src/notifications-capability.vala"
					_tmp8__length1 = capabilities_length1;
#line 58 "../src/notifications-capability.vala"
					if (!(i < _tmp8__length1)) {
#line 58 "../src/notifications-capability.vala"
						break;
#line 1604 "notifications-capability.c"
					}
#line 59 "../src/notifications-capability.vala"
					_tmp9_ = capabilities;
#line 59 "../src/notifications-capability.vala"
					_tmp9__length1 = capabilities_length1;
#line 59 "../src/notifications-capability.vala"
					_tmp10_ = _tmp9_[i];
#line 59 "../src/notifications-capability.vala"
					_tmp11_ = _tmp10_;
#line 59 "../src/notifications-capability.vala"
					_tmp13_ = (NULL == _tmp11_) ? 0 : g_quark_from_string (_tmp11_);
#line 59 "../src/notifications-capability.vala"
					if (_tmp13_ == ((0 != _tmp12_label0) ? _tmp12_label0 : (_tmp12_label0 = g_quark_from_static_string ("actions")))) {
#line 59 "../src/notifications-capability.vala"
						switch (0) {
#line 1620 "notifications-capability.c"
							default:
							{
#line 61 "../src/notifications-capability.vala"
								self->priv->have_actions = TRUE;
#line 62 "../src/notifications-capability.vala"
								break;
#line 1627 "notifications-capability.c"
							}
						}
					} else if (_tmp13_ == ((0 != _tmp12_label1) ? _tmp12_label1 : (_tmp12_label1 = g_quark_from_static_string ("persistence")))) {
#line 59 "../src/notifications-capability.vala"
						switch (0) {
#line 1633 "notifications-capability.c"
							default:
							{
#line 65 "../src/notifications-capability.vala"
								self->priv->have_persistence = TRUE;
#line 66 "../src/notifications-capability.vala"
								break;
#line 1640 "notifications-capability.c"
							}
						}
					}
				}
			}
		}
#line 51 "../src/notifications-capability.vala"
		_g_object_unref0 (_tmp0_);
#line 1649 "notifications-capability.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 51 "../src/notifications-capability.vala"
		g_clear_error (&_inner_error0_);
#line 1656 "notifications-capability.c"
	}
	__finally0:
#line 51 "../src/notifications-capability.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 51 "../src/notifications-capability.vala"
		capabilities = (_vala_array_free (capabilities, capabilities_length1, (GDestroyNotify) g_free), NULL);
#line 51 "../src/notifications-capability.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 51 "../src/notifications-capability.vala"
		g_clear_error (&_inner_error0_);
#line 1667 "notifications-capability.c"
	}
#line 47 "../src/notifications-capability.vala"
	capabilities = (_vala_array_free (capabilities, capabilities_length1, (GDestroyNotify) g_free), NULL);
#line 47 "../src/notifications-capability.vala"
	return obj;
#line 1673 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_class_init (PomodoroNotificationsCapabilityClass * klass,
                                              gpointer klass_data)
{
#line 37 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_parent_class = g_type_class_peek_parent (klass);
#line 37 "../src/notifications-capability.vala"
	g_type_class_adjust_private_offset (klass, &PomodoroNotificationsCapability_private_offset);
#line 37 "../src/notifications-capability.vala"
	((PomodoroCapabilityClass *) klass)->enable = (void (*) (PomodoroCapability*)) pomodoro_notifications_capability_real_enable;
#line 37 "../src/notifications-capability.vala"
	((PomodoroCapabilityClass *) klass)->disable = (void (*) (PomodoroCapability*)) pomodoro_notifications_capability_real_disable;
#line 37 "../src/notifications-capability.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_notifications_capability_constructor;
#line 37 "../src/notifications-capability.vala"
	G_OBJECT_CLASS (klass)->finalize = pomodoro_notifications_capability_finalize;
#line 1692 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_instance_init (PomodoroNotificationsCapability * self,
                                                 gpointer klass)
{
#line 37 "../src/notifications-capability.vala"
	self->priv = pomodoro_notifications_capability_get_instance_private (self);
#line 44 "../src/notifications-capability.vala"
	self->priv->have_actions = FALSE;
#line 45 "../src/notifications-capability.vala"
	self->priv->have_persistence = FALSE;
#line 1705 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_finalize (GObject * obj)
{
	PomodoroNotificationsCapability * self;
#line 37 "../src/notifications-capability.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_NOTIFICATIONS_CAPABILITY, PomodoroNotificationsCapability);
#line 39 "../src/notifications-capability.vala"
	_g_object_unref0 (self->priv->settings);
#line 40 "../src/notifications-capability.vala"
	_g_object_unref0 (self->priv->timer);
#line 41 "../src/notifications-capability.vala"
	_g_object_unref0 (self->priv->screen_notification);
#line 42 "../src/notifications-capability.vala"
	_g_object_unref0 (self->priv->proxy);
#line 37 "../src/notifications-capability.vala"
	G_OBJECT_CLASS (pomodoro_notifications_capability_parent_class)->finalize (obj);
#line 1724 "notifications-capability.c"
}

static GType
pomodoro_notifications_capability_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroNotificationsCapabilityClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_notifications_capability_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroNotificationsCapability), 0, (GInstanceInitFunc) pomodoro_notifications_capability_instance_init, NULL };
	GType pomodoro_notifications_capability_type_id;
	pomodoro_notifications_capability_type_id = g_type_register_static (POMODORO_TYPE_CAPABILITY, "PomodoroNotificationsCapability", &g_define_type_info, 0);
	PomodoroNotificationsCapability_private_offset = g_type_add_instance_private (pomodoro_notifications_capability_type_id, sizeof (PomodoroNotificationsCapabilityPrivate));
	return pomodoro_notifications_capability_type_id;
}

GType
pomodoro_notifications_capability_get_type (void)
{
	static volatile gsize pomodoro_notifications_capability_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_notifications_capability_type_id__once)) {
		GType pomodoro_notifications_capability_type_id;
		pomodoro_notifications_capability_type_id = pomodoro_notifications_capability_get_type_once ();
		g_once_init_leave (&pomodoro_notifications_capability_type_id__once, pomodoro_notifications_capability_type_id);
	}
	return pomodoro_notifications_capability_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 29 "../src/aggregated-entry.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1756 "notifications-capability.c"
		gssize i;
#line 29 "../src/aggregated-entry.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 29 "../src/aggregated-entry.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 29 "../src/aggregated-entry.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1764 "notifications-capability.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 29 "../src/aggregated-entry.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 29 "../src/aggregated-entry.vala"
	g_free (array);
#line 1779 "notifications-capability.c"
}

