/* utils.c generated by valac 0.56.14, the Vala compiler
 * generated from utils.vala, do not modify */

/*
 * Copyright (c) 2013 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include "gnome-pomodoro.h"
#include <float.h>
#include <math.h>

#define _g_free0(var) (var = (g_free (var), NULL))

VALA_EXTERN gchar* pomodoro_format_time (gint seconds);

gchar*
pomodoro_format_time (gint seconds)
{
	gint minutes = 0;
	gint hours = 0;
	gchar* str = NULL;
	gchar* _tmp0_;
	gboolean _tmp2_ = FALSE;
	gchar* result;
#line 27 "../src/utils.vala"
	minutes = (seconds / 60) % 60;
#line 28 "../src/utils.vala"
	hours = seconds / 3600;
#line 29 "../src/utils.vala"
	_tmp0_ = g_strdup ("");
#line 29 "../src/utils.vala"
	str = _tmp0_;
#line 31 "../src/utils.vala"
	if (hours > 0) {
#line 61 "utils.c"
		gchar* _tmp1_;
#line 32 "../src/utils.vala"
		_tmp1_ = g_strdup_printf (ngettext ("%d hour", "%d hours", (gulong) hours), hours);
#line 32 "../src/utils.vala"
		_g_free0 (str);
#line 32 "../src/utils.vala"
		str = _tmp1_;
#line 69 "utils.c"
	}
#line 36 "../src/utils.vala"
	if (minutes > 0) {
#line 73 "utils.c"
		const gchar* _tmp3_;
#line 36 "../src/utils.vala"
		_tmp3_ = str;
#line 36 "../src/utils.vala"
		_tmp2_ = _tmp3_ != NULL;
#line 79 "utils.c"
	} else {
#line 36 "../src/utils.vala"
		_tmp2_ = FALSE;
#line 83 "utils.c"
	}
#line 36 "../src/utils.vala"
	if (_tmp2_) {
#line 87 "utils.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 37 "../src/utils.vala"
		_tmp4_ = str;
#line 37 "../src/utils.vala"
		_tmp5_ = g_strconcat (_tmp4_, " ", NULL);
#line 37 "../src/utils.vala"
		_g_free0 (str);
#line 37 "../src/utils.vala"
		str = _tmp5_;
#line 98 "utils.c"
	}
#line 40 "../src/utils.vala"
	if (minutes > 0) {
#line 102 "utils.c"
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 41 "../src/utils.vala"
		_tmp6_ = str;
#line 41 "../src/utils.vala"
		_tmp7_ = g_strdup_printf (ngettext ("%d minute", "%d minutes", (gulong) minutes), minutes);
#line 41 "../src/utils.vala"
		_tmp8_ = _tmp7_;
#line 41 "../src/utils.vala"
		_tmp9_ = g_strconcat (_tmp6_, _tmp8_, NULL);
#line 41 "../src/utils.vala"
		_g_free0 (str);
#line 41 "../src/utils.vala"
		str = _tmp9_;
#line 41 "../src/utils.vala"
		_g_free0 (_tmp8_);
#line 121 "utils.c"
	}
#line 45 "../src/utils.vala"
	result = str;
#line 45 "../src/utils.vala"
	return result;
#line 127 "utils.c"
}

/**
     * Returns the number of seconds since January 1, 1970 UTC.
     */
gdouble
pomodoro_get_current_time (void)
{
	gdouble result;
#line 53 "../src/utils.vala"
	result = ((gdouble) g_get_real_time ()) / 1000000.0;
#line 53 "../src/utils.vala"
	return result;
#line 141 "utils.c"
}

